/*
 *  BINGODesktop.java
 *
 *  Created on 12. Juli 2002, 11:09
 */
package bingo.util;

import bingo.main.*;
import bingo.svm.*;
import bingo.db.*;
import bingo.base.*;
import bingo.crawler.*;
import bingo.iteration.*;

import stored.*;
import stored.mi.*;

import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.text.*;


/**
 *@author     martin
 *@created    14. August 2002
 */
public class BINGODesktop extends JFrame implements ActionListener, ItemListener {
  
  private SessionBuffer session;
  private JDesktopPane desktopPane;
  
  private JMenuBar menuBar = new JMenuBar();
  
  private JPanel panel1 = new JPanel();
  private JPanel panel2 = new JPanel();
  private JPanel panel3 = new JPanel();
  private JPanel panel4 = new JPanel();
  private JLabel label1 = new JLabel();
  private JLabel label2 = new JLabel();
  private JLabel label3 = new JLabel();
  private JLabel label4 = new JLabel();
  
  private JCheckBoxMenuItem miStem = new JCheckBoxMenuItem( "Stemming von Worttermen" );
  private JCheckBoxMenuItem miCut = new JCheckBoxMenuItem( "Lschen von Stopwrtern" );
  private JCheckBoxMenuItem miWN = new JCheckBoxMenuItem( "WordNet Dictionary Lookup" );
  private JCheckBoxMenuItem miSelectionType = new JCheckBoxMenuItem( "Feature-Selektion auf Vereinigung der Feature-Rume der jew. Unterkategorien" );
  private JCheckBoxMenuItem miModellingType = new JCheckBoxMenuItem( "Knotenspezifisches Modellieren nur auf Dokumenten aus jew. Unterkategorien" );
  public JCheckBoxMenuItem miStored = new JCheckBoxMenuItem( "Feature-Berechnung auf Oracle-Server", false );

  private JMenuItem miReadModelDB;
  private JMenuItem miWriteModelDB;
  private JMenuItem miReadIDFDB;
  
  private JMenuItem miHITS;
  private JMenuItem miDF;
  private JMenuItem miMI;

  private JButton bBase = new JButton( "Trainingsbasis" );
  private JButton bCrawl = new JButton( "Crawler" );
  private JButton bDB = new JButton( "Datenbank" );
  private JButton bIter = new JButton( "Iterations-Manager" );
  
  private Font f = new Font( "Serif", Font.ITALIC, 14 );
  private Font ff = new Font( "Serif", Font.BOLD, 16 );
  
  static int openFrameCount = 0;
  final static int xOffset = 50, yOffset = 50;
  
  public JMenuItem miStart;
  public JMenuItem miStop;
  public JMenuItem miReset;

  protected BINGODesktop() {
    
    session = SessionBuffer.getInstance();
    
    addWindowListener( new CloseWindow( this ) );
    
    setTitle( "BINGO! - Bookmark-Induced Gathering of Information" );
    
    // MenLeiste
    setJMenuBar( menuBar );
    
    // Men Datei
    JMenu mFile = new JMenu( "BINGO!" );
    menuBar.add( mFile );
    JMenuItem miExit = addMenuItem( mFile, "Beenden" );
    
    // Men Base
    JMenu mBase = new JMenu( "Trainingsbasis" );
    menuBar.add( mBase );
    JMenuItem miBase = addMenuItem( mBase, "Trainingsbasis bearbeiten" );
    mBase.addSeparator();
    JMenuItem miFeat = addMenuItem( mBase, "Berechne Feature-Vektoren" );
    
    // Men Features
    JMenu mFeatures = new JMenu( "Feature-Rume" );
    menuBar.add( mFeatures );
    miDF = addMenuItem( mFeatures, "Berechne DF/IDF" );
    miMI = addMenuItem( mFeatures, "Berechne MI" );
    mFeatures.addSeparator();
    JMenu mInMemory = new JMenu( "<In-Memory>" );
    JMenuItem miINDF = addMenuItem( mInMemory, "DF/IDF (keine Datenbank)" );
    JMenuItem miINMI = addMenuItem( mInMemory, "MI (keine Datenbank)" );
    mFeatures.add( mInMemory );
    mFeatures.addSeparator();
    JMenu readIDF = new JMenu( "Feature-Rume lesen" );
    mFeatures.add( readIDF );
    JMenuItem miReadIDFFile = addMenuItem( readIDF, "Features aus Datei" );
    miReadIDFDB = addMenuItem( readIDF, "Features aus Datenbank" );
    JMenu writeIDF = new JMenu( "Feature-Rume schreiben" );
    mFeatures.add( writeIDF );
    JMenuItem miWriteIDFFile = addMenuItem( writeIDF, "Features in Datei" );
    
    // Men SVM
    JMenu mSVM = new JMenu( "SVM" );
    menuBar.add( mSVM );
    JMenuItem miModel = addMenuItem( mSVM, "Modellierung" );
    mSVM.addSeparator();
    JMenu readModel = new JMenu( "SVM-Modell lesen" );
    mSVM.add( readModel );
    JMenuItem miReadModelFile = addMenuItem( readModel, "Modell aus Datei" );
    miReadModelDB = addMenuItem( readModel, "Modell aus Datenbank" );
    JMenu writeModel = new JMenu( "SVM-Modell schreiben" );
    mSVM.add( writeModel );
    JMenuItem miWriteModelFile = addMenuItem( writeModel, "Modell in Datei" );
    miWriteModelDB = addMenuItem( writeModel, "Modell in Datenbank" );
    
    // Men HITS
    JMenu mHITS = new JMenu( "Linkanalyse" );
    menuBar.add( mHITS );
    miHITS = addMenuItem( mHITS, "Berechne HITS" );
    
    // Men DB
    JMenu mDB = new JMenu( "Datenbank" );
    menuBar.add( mDB );
    JMenuItem miDB = addMenuItem( mDB, "Datenbank-Interface" );
    mDB.addSeparator();
    //JMenuItem miStops = addMenuItem( mDB, "Stopwrter in DB schreiben" );
    //mDB.addSeparator();
    JMenuItem miClient = addMenuItem( mDB, "SQL-Mini-Client" );
    
    // Men XML
    JMenu mXML = new JMenu( "XML" );
    //menuBar.add( mXML );
    JMenuItem miXIDF = addMenuItem( mXML, "Berechne DF/IDF" );
    JMenuItem miXMI = addMenuItem( mXML, "Berechne MI" );
    
    // Men myfeatures
    JMenu myfeatures = new JMenu( "Myfeatures" );
    //menuBar.add( myfeatures );
    JMenuItem miModelStrat = addMenuItem( myfeatures, "Modellstrategie" );
    myfeatures.addSeparator();
    JMenuItem miClassyStrat = addMenuItem( myfeatures, "Classifystrategie" );
    myfeatures.addSeparator();
    JMenuItem miPrepModel = addMenuItem( myfeatures, "Modellierung vorbereiten" );
    
    // Men Crawler
    JMenu mCrawler = new JMenu( "Crawler" );
    menuBar.add( mCrawler );
    JMenuItem miCrawler = addMenuItem( mCrawler, "Crawler-Interface" );
    JMenuItem miRoots = addMenuItem( mCrawler, "Root-URLs bearbeiten" );
    mCrawler.addSeparator();
    miStart = addMenuItem( mCrawler, "Start" );
    miStop = addMenuItem( mCrawler, "Stop" );
    miReset = addMenuItem( mCrawler, "Reset" );
    mCrawler.addSeparator();
    JMenuItem miSettings = addMenuItem( mCrawler, "Optionen" );
    
    // Men Iteration
    JMenu mIteration = new JMenu( "Iterations-Manager" );
    menuBar.add( mIteration );
    JMenuItem miIter = addMenuItem( mIteration, "Iterationsprogramm aufstellen" );
    
    // Einstellungen
    JMenu mSettings = new JMenu( "Globale Einstellungen" );
    menuBar.add( mSettings );
    JMenu mStemmer = new JMenu( "Parser" );
    miStem.setState( session.bSTEM );
    miCut.setState( session.bCUT );
    miWN.setState( session.bWN );
    mStemmer.add( miStem );
    mStemmer.add( miCut );
    //mStemmer.add( miWN );
    mSettings.add( mStemmer );
    JMenu mModel = new JMenu( "Modellierung" );
    miModellingType.setState( session.getObeyLevel() );
    mModel.add( miModellingType );
    mSettings.add( mModel );
    JMenu mClass = new JMenu( "Klassifikation" );
    mClass.add( miSelectionType );
    miSelectionType.setState( session.getUseUnionSelect() );
    mSettings.add( mClass );
    JMenu mStored = new JMenu( "Stored-Procedures" );
    mStored.add( miStored );
    mSettings.add( mStored );
    
    // Hilfe
    JMenu mHelp = new JMenu( "Hilfe" );
    menuBar.add( mHelp );
    JMenuItem miHelp = addMenuItem( mHelp, "Was soll das?" );
    
    // ActionListener fr alle Mens registrieren
    miExit.addActionListener( this );
    miBase.addActionListener( this );
    miFeat.addActionListener( this );
    miDF.addActionListener( this );
    miMI.addActionListener( this );
    miReadIDFFile.addActionListener( this );
    miReadIDFDB.addActionListener( this );
    miWriteIDFFile.addActionListener( this );
    miModel.addActionListener( this );
    miReadModelFile.addActionListener( this );
    miReadModelDB.addActionListener( this );
    miWriteModelFile.addActionListener( this );
    miWriteModelDB.addActionListener( this );
    miHITS.addActionListener( this );
    miDB.addActionListener( this );
    miClient.addActionListener( this );
    miXIDF.addActionListener( this );
    miXMI.addActionListener( this );
    miModelStrat.addActionListener( this );
    miClassyStrat.addActionListener( this );
    miPrepModel.addActionListener( this );
    miCrawler.addActionListener( this );
    miRoots.addActionListener( this );
    miSettings.addActionListener( this );
    miIter.addActionListener( this );
    miHelp.addActionListener( this );
    miStart.addActionListener( this );
    miStop.addActionListener( this );
    miReset.addActionListener( this );
    miINDF.addActionListener( this );
    miINMI.addActionListener( this );
    bBase.addActionListener( this );
    bCrawl.addActionListener( this );
    bDB.addActionListener( this );
    bIter.addActionListener( this );
    
    miStem.addItemListener( this );
    miCut.addItemListener( this );
    miWN.addItemListener( this );
    miModellingType.addItemListener( this );
    miSelectionType.addItemListener( this );
    miStored.addItemListener( this );

    desktopPane = new JDesktopPane();
    
    JPanel jumpTo = new JPanel();
    jumpTo.setLayout( new FlowLayout() );
    jumpTo.add( new JLabel( "Tasks:" ) );
    jumpTo.add( bBase );
    jumpTo.add( bCrawl );
    jumpTo.add( bDB );
    jumpTo.add( bIter );
    
    Container container = new Container();
    container.setLayout( new BorderLayout() );
    
    container.add( desktopPane, BorderLayout.CENTER );
    container.add( jumpTo, BorderLayout.SOUTH );
    
    setContentPane( container );
    
    desktopPane.setDragMode( JDesktopPane.OUTLINE_DRAG_MODE );
    
    setVisible( true );
    setExtendedState( MAXIMIZED_BOTH );
    setDefaultCloseOperation( EXIT_ON_CLOSE );
    
    miStop.setEnabled( false );

    itemStateChanged( null );
    
  }
  

  public void add( JInternalFrame frame ) {
    openFrameCount++;
    
    frame.setVisible( true );
    //necessary as of kestrel
    desktopPane.add( frame );
    
    frame.setLocation( xOffset * openFrameCount, yOffset * openFrameCount );
    
    try {
      frame.setSelected( true );
    } catch ( java.beans.PropertyVetoException e ) {}
    
  }
  
  
  private JMenuItem addMenuItem( JMenu target, String text ) {
    JMenuItem mi = new JMenuItem( text );
    target.add( mi );
    return mi;
  }
  
  
  public void actionPerformed( java.awt.event.ActionEvent e ) {
    String cmd = e.getActionCommand();
    try {
      if ( cmd.equals( "Beenden" ) ) {
        System.exit( 0 );
      } else if ( cmd.startsWith( "Trainingsbasis" ) ) {
        BaseFrame bf = BaseFrame.getInstance();
        bf.setIcon( false );
        bf.setSelected( true );
        bf.setVisible( true );
      } else if ( cmd.equals( "Berechne Feature-Vektoren" ) ) {
        BaseFrame bf = BaseFrame.getInstance();
        bf.setIcon( false );
        bf.setSelected( true );
        bf.setVisible( true );
        new FeatureDialog( BINGODesktop.getInstance(), bf.getTrainingData(), bf.table.getSelectedRows() ).setVisible( true );
        bf.buildTable( bf.getTrainingData() );
      } else if ( cmd.equals( "Berechne DF/IDF" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl Features nach DF", session.numDF );
        nid.setVisible( true );
        if ( !nid.canceled ) {
          new berechne_df( nid.getNumber() ).go();
        }
        session.setFeaturesPerClass( nid.getNumber() );
        new IDFReader( BINGODesktop.getInstance(), true ).setVisible( true );
      } else if ( cmd.equals( "Berechne MI" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl Features nach MI", session.numMI );
        nid.setVisible( true );
        if ( !nid.canceled) {
          session.setFeaturesPerClass( nid.getNumber() );
          new MiManager( nid.getNumber() ).go();
        }
        new IDFReader( BINGODesktop.getInstance(), true ).setVisible( true );
      } else if ( cmd.equals( "Berechne HITS" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl HITS Iterationen", session.numHITS );
        nid.setVisible( true );
        new berechne_hits( nid.getNumber() ).go();
      } else if ( cmd.equals( "Modell aus Datei" ) ) {
        FileDialog fileDialog = new FileDialog( BINGODesktop.getInstance(), "SVM-Modellhierarchie aus Datei lesen", FileDialog.LOAD );
        fileDialog.setVisible( true );
        if ( fileDialog.getFile() == null ) {
          return;
        }
        String sFileName = fileDialog.getDirectory() + fileDialog.getFile();
        Vector nodeModelVector = (Vector)FileInterface.readZippedObject( sFileName );
        NodeModel nm = (NodeModel)nodeModelVector.firstElement();
        if ( nm != null ) {
          TreeNode rootNode = ( (DefaultMutableTreeNode)nm.getNode() ).getRoot();
          session.setModellingType( nm.getModellingType() );
          session.setNodeModel( nodeModelVector );
          session.setRootNode( (DefaultMutableTreeNode)rootNode );
          SVMTreeClassifier.setModel( rootNode, nodeModelVector );
        }
      } else if ( cmd.equals( "Modell aus Datenbank" ) ) {
        new ReadModelDialog( BINGODesktop.getInstance() ).setVisible( true );
      } else if ( cmd.equals( "Features aus Datei" ) ) {
        FileDialog fileDialog = new FileDialog( BINGODesktop.getInstance(), "Feature-Rume aus Datei lesen", FileDialog.LOAD );
        fileDialog.setVisible( true );
        if ( fileDialog.getFile() == null ) {
          return;
        }
        String sFileName = fileDialog.getDirectory() + fileDialog.getFile();
        session.setAllFeatureSpaces( (Hashtable)FileInterface.readZippedObject( sFileName ) );
      } else if ( cmd.equals( "Features aus Datenbank" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl Features nach MI", session.numMI );
        nid.setVisible( true );
        if ( !nid.canceled ) {
          session.setFeaturesPerClass( nid.getNumber() );
        }
        new IDFReader( BINGODesktop.getInstance(), true ).setVisible( true );
      } else if ( cmd.equals( "Modell in Datei" ) ) {
        FileDialog fileDialog = new FileDialog( BINGODesktop.getInstance(), "SVM-Modellhierarchie in Datei schreiben", FileDialog.SAVE );
        fileDialog.setVisible( true );
        if ( fileDialog.getFile() == null ) {
          return;
        }
        String sFileName = fileDialog.getDirectory() + fileDialog.getFile();
        FileInterface.writeZippedObject( session.getNodeModel(), sFileName );
      } else if ( cmd.equals( "Modell in Datenbank" ) ) {
        session.dbinterface.pushModel( 0 );
      } else if ( cmd.equals( "Features in Datei" ) ) {
        FileDialog fileDialog = new FileDialog( BINGODesktop.getInstance(), "Feature-Rume in Datei schreiben", FileDialog.SAVE );
        fileDialog.setVisible( true );
        if ( fileDialog.getFile() == null ) {
          return;
        }
        String sFileName = fileDialog.getDirectory() + fileDialog.getFile();
        FileInterface.writeZippedObject( session.getAllFeatureSpaces(), sFileName );
      } else if ( cmd.equals( "Modellierung" ) ) {
        new SVMModelFrame( BINGODesktop.getInstance() ).setVisible( true );
      } else if ( cmd.startsWith( "Datenbank" ) ) {
        DBFrame df = DBFrame.getInstance();
        df.setIcon( false );
        df.setSelected( true );
        df.setVisible( true );
      } else if ( cmd.equals( "SQL-Mini-Client" ) ) {
        MiniClient mc = MiniClient.getInstance();
        mc.setVisible( true );
      } else if ( cmd.startsWith( "Crawler" ) ) {
        CrawlerFrame cf = CrawlerFrame.getInstance();
        cf.setIcon( false );
        cf.setSelected( true );
        cf.setVisible( true );
        cf.setVisible( true );
      } else if ( cmd.startsWith( "Start" ) ) {
        CrawlerFrame cf = CrawlerFrame.getInstance();
        cf.setIcon( false );
        cf.setSelected( true );
        cf.setVisible( true );
        cf.setVisible( true );
        cf.initCrawler();
      } else if ( cmd.startsWith( "Stop" ) ) {
        CrawlerFrame cf = CrawlerFrame.getInstance();
        cf.setIcon( false );
        cf.setSelected( true );
        cf.setVisible( true );
        cf.setVisible( true );
        if ( cf.crawler != null ) {
          cf.crawler.stop();
        }
      } else if ( cmd.startsWith( "Reset" ) ) {
        CrawlerFrame cf = CrawlerFrame.getInstance();
        cf.setIcon( false );
        cf.setSelected( true );
        cf.setVisible( true );
        cf.setVisible( true );
        if ( cf.crawler != null ) {
          cf.crawler.reset();
        }
      } else if ( cmd.equals( "Root-URLs bearbeiten" ) ) {
        RootDialog rd = RootDialog.getInstance( BINGODesktop.getInstance() );
        CrawlerFrame cf = CrawlerFrame.getInstance();
        rd.setRoots( cf.getCrawlerURLs() );
        rd.setVisible( true );
      } else if ( cmd.equals( "Optionen" ) ) {
        ControlDialog cd = ControlDialog.getInstance();
        cd.setVisible( true );
      } else if ( cmd.startsWith( "Iteration" ) ) {
        IterationFrame it = IterationFrame.getInstance();
        it.setIcon( false );
        it.setSelected( true );
        it.setVisible( true );
      } else if ( cmd.startsWith( "DF/IDF (keine Datenbank)" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl Features nach DF", session.numDF );
        nid.setVisible( true );
        if ( !nid.canceled) {
          new xml.DFManager( nid.getNumber() ).work();
        }
        session.setFeaturesPerClass( nid.getNumber() );
      } else if ( cmd.startsWith( "MI (keine Datenbank)" ) ) {
        NumberInDialog nid = new NumberInDialog( "Anzahl Features nach MI", session.numMI );
        nid.setVisible( true );
        if ( !nid.canceled) {
          new xml.MIManager( nid.getNumber() ).work();
        }
        session.setFeaturesPerClass( nid.getNumber() );
      }
    } catch ( Exception any ) {
      System.err.println( any );
    }
  }
  
  
  public void itemStateChanged( ItemEvent e ) {
    session.setCUT( miCut.getState() );
    session.setSTEM( miStem.getState() );
    session.setUseWordNet( miWN.getState() );
    session.setUseUnionSelect( miSelectionType.getState() );
    session.setObeyLevel( miModellingType.getState() );
    //session.setUseStored( miStored.getState() );
  }
  
  
  private static BINGODesktop desktop = null;
  
  
  public static BINGODesktop getInstance() {
    if ( desktop == null ) {
      desktop = new BINGODesktop();
    }
    return desktop;
  }
  
  public static boolean isNull() {
    return desktop == null;
  }
  
  public void disableDBMenues() {
    if ( !session.dbConnect ) {
      miReadModelDB.setEnabled( false );
      miWriteModelDB.setEnabled( false );
      miReadIDFDB.setEnabled( false );
      miSelectionType.setEnabled( false );
      miHITS.setEnabled( false );
      miDF.setEnabled( false );
      miMI.setEnabled( false );
      miStored.setEnabled( false );
    }
  }
}
