/*
 * DummyHttpURLConnection.java
 *
 * Created on 8. Oktober 2002, 11:04
 */

package bingo.util;

import java.io.*;
import java.util.*;
import java.net.*;
import bingo.crawler.*;
import bingo.crawler.handler.*;
import bingo.crawler.handler.parser.TextItem;
import bingo.crawler.handler.parser.Source;

/**
 * Replacement for HttpURLConnection with a given Content-String!
 * @author  T
 */

public class DummyHttpURLConnection extends HttpURLConnection {
  
  private URL url;
  private String content;
  
  public DummyHttpURLConnection ( URL url, String content ) {
    super ( url );
    this.url = url;
    this.content = content;
  }

  public DummyHttpURLConnection ( URL url ) {
    super ( url );
    this.url = url;
    this.content = readURL( url.toString() );
  }
  
  public String getContentType () {
    UrlVerifier uv = new UrlVerifier ( null );
    return uv.guessContentTypeFromName ( url.toString () );
  }
  
  public InputStream getInputStream () throws IOException {
    return new ByteArrayInputStream ( content.getBytes () );
  }
  
  public boolean usingProxy () {
    return false;
  }
  
  public void disconnect () {
  }
  
  public void connect () {
  }
  
  public int getResponseCode () throws IOException {
    if ( content == null || content.length() == 0 ) {
      return HttpURLConnection.HTTP_NO_CONTENT;
    }
    return HttpURLConnection.HTTP_OK;
  }
  
  public String toString () {
    return new String ( "DUMMYCONNECTION on " + url.toString ());
  }
  
  public static String readURL ( String url ) {
    int iZeichen;
    StringBuffer sb = new StringBuffer ();
    try {
      URL sourceURL = new URL ( url );
      BufferedReader reader = new BufferedReader ( new InputStreamReader ( sourceURL.openStream () ) );
      while ( ( iZeichen = reader.read () ) != -1 ) {
        sb.append ( (char)iZeichen );
      }
      reader.close ();
    } catch ( Exception e ) {
      sb = new StringBuffer ();
    }
    return new String ( sb );
  }
  
}
