package bingo.util;

import java.awt.*;
import java.awt.event.*;
import com.sun.image.codec.jpeg.*;
import java.awt.image.BufferedImage;
import java.awt.image.DataBuffer;
import java.awt.geom.GeneralPath;
import java.io.*;
import javax.swing.*;


/**
 *  Displays a JPEG or GIF Image in a JPanel Component.
 *
 *@author     T
 *@created    4. August 2001
 */
public class ImagePanel extends JPanel {

  private static Image img;
  private static Dimension dimension;
  private static String imageFile;


  public ImagePanel( String file, Dimension d ) {
    dimension = d;
    imageFile = file;
    init();
  }


  private void init() {
    setBackground( Color.white );
    img = getToolkit().getImage( imageFile );
    try {
      MediaTracker tracker = new MediaTracker( this );
      tracker.addImage( img, 0 );
      tracker.waitForID( 0 );
    } catch ( Exception e ) {
    }
  }


  private void drawImage( int w, int h, Graphics2D g2 ) {
    BufferedImage bi = (BufferedImage)createImage( w, h );
    Graphics2D big = bi.createGraphics();

    // .. use rendering hints from DemoSurface ..
    big.setRenderingHints( g2.getRenderingHints() );
    big.setBackground( getBackground() );
    big.clearRect( 0, 0, w, h );

    int iw = img.getWidth( this );
    int ih = img.getHeight( this );

    int w_off = ( w - iw ) / 2;
    int h_off = ( h - ih ) / 2;

    big.drawImage( img, w_off, h_off, iw, ih, this );
    g2.drawImage( bi, 0, 0, this );
  }


  public void paint( Graphics g ) {
    Graphics2D g2 = (Graphics2D)g;
    g2.setBackground( getBackground() );
    g2.clearRect( 0, 0, dimension.width, dimension.height );
    g2.setRenderingHint( RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON );
    g2.setRenderingHint( RenderingHints.KEY_RENDERING,
        RenderingHints.VALUE_RENDER_QUALITY );
    drawImage( dimension.width, dimension.height, g2 );
  }
}

