package bingo.util;

import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import bingo.base.*;
import bingo.svm.*;
import bingo.db.*;
import bingo.crawler.*;


/**
 *  Dialog zur Ausgabe einer Fehlermeldung whrend des Klassifizierens bzw.
 *  Modellierens.
 *
 *@author     T
 *@created    15. Juni 2001
 */
public class NumberInDialog extends JDialog implements ActionListener {

  private JButton ok = new JButton( "Ok" );
  private JTextField label = new JTextField();
  private NumberInDialog nid;
  
  public boolean canceled = false;
  
  public NumberInDialog( String title, int number ) {
    super( BINGODesktop.getInstance(), title, true );
    this.setSize( 240, 80 );

    Container content = this.getContentPane();
    content.setLayout( new BorderLayout() );
    nid = this;
    
    KeyAdapter keyAdapter =
      new KeyAdapter() {
        public void keyPressed( KeyEvent e ) {
          if ( e.getKeyCode() == KeyEvent.VK_ENTER ) {
            nid.dispose();
          } else if ( e.getKeyCode() == KeyEvent.VK_ESCAPE ) {
            nid.canceled = true;
            nid.dispose();
          }
        }
      };

    label.addKeyListener( keyAdapter );
    
    label.setText( String.valueOf( number ) );
    label.setFont( new Font( "Serif", Font.BOLD, 15 ) );
    label.setBackground( Color.white );
    label.setForeground( Color.red );

    content.add( label, BorderLayout.NORTH );
    content.add( ok, BorderLayout.SOUTH );
    
    ok.addActionListener( this );

    setLocationRelativeTo( BINGODesktop.getInstance() );
  }


  /**
   *  berwacht den Button.
   *
   *@param  e  Das Event.
   */
  public void actionPerformed( ActionEvent e ) {
    String cmd = e.getActionCommand();
    if ( cmd.equals( "Ok" ) ) {
     super.dispose();
    }
  }

  public int getNumber() {
    try {
      return Integer.parseInt( label.getText() ); 
    } catch ( Exception e ) {
      return 0;
    }
  }
}

