package bingo.util;

import java.io.*;
import java.util.*;
import java.net.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;


/**
 *  Die Klasse dient dem Parsen einer HTML-Datei, die Stoppwrter enthlt. Die
 *  Stoppwrter werden als Vektor von Strings bereitgestellt.
 *
 *@author     T
 *@created    15. Juni 2001
 */

public class StopwordParser {

  private String sFile;
  private Vector stopwords = new Vector();


  /**
   *  Generiert ein neues Objekt vom Typ StopwordParser.
   *
   *@param  sFile  Die zu parsende HTML-Datei mit den Stoppwrtern.
   */
  public StopwordParser( String sFile ) {
    this.sFile = sFile;
  }


  /**
   *  Die Stoppwrter werden aus dem entsprechenden HTML-Dokument geparst und in
   *  einen Vektor geschrieben.
   *
   *@return    Der Vektor mit den Stoppwrtern.
   */
  public Vector parseStopwords() {
    HTMLEditorKit.ParserCallback callback =
      new HTMLEditorKit.ParserCallback() {
        boolean bStart = false;


        public void handleText( char[] data, int pos ) {
          if ( !bStart ) {
            return;
          }
          tokenize( new String( data ) );
        }


        public void handleStartTag( HTML.Tag t, MutableAttributeSet a, int pos ) {
          if ( t.toString().equals( "body" ) ) {
            bStart = true;
          }
        }

      };

    try {
      Reader f = new FileReader( sFile );
      new ParserDelegator().parse( f, callback, false );
    } catch ( Exception anyException ) {
      System.err.println( anyException );
    }
    return stopwords;
  }


  private void tokenize( String sInput ) {
    StringTokenizer st = new StringTokenizer( sInput );
    while ( st.hasMoreTokens() ) {
      String s = st.nextToken();
      stopwords.addElement( s );

    }
  }
}
