package bingo.util;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import javax.swing.event.*;
import bingo.util.*;
import java.util.*;


/**
 *  TableModel zur Verwaltung der Tabelle mit den gecrawlten URLs.
 *
 *@author     T
 *@created    15. Juni 2001
 */
public class URLClassTableModel extends AbstractTableModel {

  private SessionBuffer session = SessionBuffer.getInstance();
  private String[] columnNames;
  private Vector data = new Vector();


  public void setDataVector( Vector vector ) {
    this.data = vector;
    fireTableDataChanged();
  }


  public void setColumnNames( String[] columnNames ) {
    this.columnNames = columnNames;
  }


  public void setValueAt( Object value, int row, int col ) {
    try {
      Object[] objects = (Object[])data.elementAt( row );
      objects[col] = value;
      fireTableCellUpdated( row, col );
    } catch ( ArrayIndexOutOfBoundsException e ) {
    }
  }


  public Vector getDataVector() {
    return data;
  }


  public int getColumnCount() {
    return columnNames.length;
  }


  public int getRowCount() {
    return data.size();
  }


  public String getColumnName( int col ) {
    return columnNames[col];
  }


  public Object getValueAt( int row, int col ) {
    try {
      Object[] objects = (Object[])data.elementAt( row );
      return objects[col];
    } catch ( ArrayIndexOutOfBoundsException e ) {
      return new String( "0" );
    }
  }


  public Class getColumnClass( int c ) {
    try {
      return getValueAt( 0, c ).getClass();
    } catch ( NullPointerException npe ) {
    }
    return new String().getClass();
  }


  public boolean isCellEditable( int row, int col ) {
    if ( col == 2 ) {
      return true;
    } else {
      return false;
    }
  }


  public void addRow( Object[] objects ) {
    data.addElement( objects );
    fireTableRowsInserted( data.size(), data.size() );
  }


  public void removeRow( int row ) {
    data.removeElementAt( row );
    fireTableDataChanged();
  }


  public void removeAllRows() {
    data.removeAllElements();
    fireTableDataChanged();
  }

}

