package bingo;

import java.lang.*;
import java.util.*;
import java.util.Map.*;
import java.sql.*;

public class bingo_features_check
{
   static Connection conn;
   static oracle.jdbc.driver.OracleDriver oracleDriver;
   public static String errorMessage = null;
   public static boolean hasError = false;
   
   public int numFeaturesInsgesamt = 0;
   public int numFeaturesPositive = 0;
   public int numFeaturesInsgesamtPositive = 0;
   
   public int countLowerDF = 0;
   public int countHigherDF = 0;
   
   public String className = null;
   public int DF = 0;
   
   public bingo_features_check()
   {
      verifyConnection();
   }
   
   public static void openConnection() throws Exception
   {
      if (bingo_feed_userInfos.getDatenVorhanden())
      {
         openConnection(bingo_feed_userInfos.getDBVerbindung(), bingo_feed_userInfos.getUsername(), bingo_feed_userInfos.getPasswort());
      }
   }
   
   public static void openConnection(String connString, String user, String pass) throws Exception
   {
      if (oracleDriver == null)
      {
         oracleDriver = new oracle.jdbc.driver.OracleDriver();
         DriverManager.registerDriver(oracleDriver);
      }
      conn = DriverManager.getConnection(connString, user, pass);
   }
   
   public static void captureError(Exception e)
   {
      errorMessage = e.getMessage();
      hasError = true;
   }
   
   public void noError()
   {
      this.errorMessage = null;
      this.hasError = false;
   }
   
   public void closeConnection()
   {
      try
      {
         if (conn != null && !conn.isClosed())
         {
            try
            {
               conn.close();
            }
            catch (Exception e)
            { }
            conn = null;
         }
      }
      catch (Exception e1)
      {
         conn = null;
      }
   }
   
   public static boolean verifyConnection()
   {
      try
      {
         if (conn == null || conn.isClosed())
         {
            conn = null;
            openConnection();
         }
         return (conn != null && !conn.isClosed());
      }
      catch (Exception e)
      {return false;}
   }
   
   public ArrayList getClassesForPulldown()
   {
      ArrayList result = new ArrayList(50);
      if (!verifyConnection())
         return result;
      
      try
      {
         long id = (long)0;
         Statement stmt = conn.createStatement();
         //         ResultSet rset = stmt.executeQuery("SELECT Class_ID FROM CLASSES Where Name='ROOT/'");
         //         if (rset.next())
         //            id = rset.getLong(1);
         //         rset.close(); rset=null;
         
         addSubtreeForClass("ROOT/", result, stmt);
         
         stmt.close();stmt=null;
      }
      catch (Exception e)
      {
         captureError(e);
         return result;
      }
/*
      ArrayList output = new ArrayList(50);
      output.add("<option value=\"0\">Auswahl");
 
      Iterator it = result.iterator();
      while (it.hasNext())
      {
        String classLine = (String)it.next();
        String tempLine = classLine.replaceAll("/", "");
        int diff = classLine.length() - tempLine.length();
        tempLine=null;
        classLine = className.substring(0, classLine.length()-1);
        classLine = className.substring(classLine.lastIndexOf("/")+1);
        for (int i=1; i<(diff-1)*3; i++)
        {
          classLine = classLine + " &nbsp; ";
        }
      }
 */
      
      noError();
      return result;
   }
   
   public void addSubtreeForClass(String classname, ArrayList result, Statement stmt) throws Exception
   {
      ResultSet rset = stmt.executeQuery("SELECT Name, Class_id from Classes WHERE Name LIKE '%" + classname + "%/' AND name NOT LIKE '" + classname  + "%/%/'");
      HashMap subtree = new HashMap(20);
      while (rset.next())
      {
         String className = rset.getString(1);
         subtree.put(className, new Long(rset.getLong(2)));
      }
      rset.close();
      rset=null;
      
      Iterator it = subtree.entrySet().iterator();
      while (it.hasNext())
      {
         Entry entry = (Entry)it.next();
         String classLine = (String)entry.getKey();
         String tempLine = classLine.replaceAll("/", "");
         int diff = classLine.length() - tempLine.length();
         tempLine=null;
         classLine = classLine.substring(0, classLine.length()-1);
         classLine = classLine.substring(classLine.lastIndexOf("/")+1);
         for (int i=1; i<=(diff-2)*3; i++)
         {
            classLine = "&nbsp;" + classLine;
         }
         result.add("<OPTION VALUE=\"" + (Long)entry.getValue() + "\"> " + classLine);
         addSubtreeForClass((String)entry.getKey(), result, stmt);
         entry = null;
         classLine = null;
      }
      it=null;
   }
   
   public ArrayList getFeaturesForClass(long id, int df, String filter, int amount)
   {
      ArrayList result = new ArrayList(300);
      
      this.DF = df;
      
      if (!verifyConnection())
         return result;
      
      try
      {
         PreparedStatement  pstmt = conn.prepareStatement("select count(*) from Classfeatures Where Class_id = ?");
         pstmt.setLong(1, id);
         ResultSet rset = pstmt.executeQuery();
         rset.next();
         numFeaturesInsgesamt = rset.getInt(1);
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         pstmt = conn.prepareStatement("select Name FROM Classes WHERE Class_ID = ?");
         pstmt.setLong(1, id);
         rset = pstmt.executeQuery();
         if (rset.next())
            this.className = rset.getString(1);
         else
            this.className = "unknown";
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         pstmt = conn.prepareStatement("select count(*) FROM ClassFeatures WHERE Class_ID = ? AND Evaluation > 0");
         pstmt.setLong(1, id);
         rset = pstmt.executeQuery();
         rset.next();
         numFeaturesInsgesamtPositive = rset.getInt(1);        
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         pstmt = conn.prepareStatement("select count(*) from Classfeatures Where Class_id = ? AND DF >= ?");
         pstmt.setLong(1, id);
         pstmt.setLong(2, df+1);
         rset = pstmt.executeQuery();
         rset.next();
         countHigherDF = rset.getInt(1);
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         pstmt = conn.prepareStatement("select count(*) from Classfeatures Where Class_id = ? AND DF >= ?");
         pstmt.setLong(1, id);
         pstmt.setLong(2, df-1);
         rset = pstmt.executeQuery();
         rset.next();
         countLowerDF = rset.getInt(1);
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         if (filter != null && filter.equals("pos"))
            pstmt = conn.prepareStatement("select term, df, to_char(mi,'9.9999'), evaluation, CEIL (100 * mi / (select AVG(mi) from ClassFeatures where Class_ID = ?)) from ClassFeatures where Class_ID = ? AND DF >= ? AND Evaluation > 0 order by MI DESC");
         else
            pstmt = conn.prepareStatement("select term, df, to_char(mi,'9.9999'), evaluation, CEIL (100 * mi / (select AVG(mi) from ClassFeatures where Class_ID = ?)) from ClassFeatures where Class_ID = ? AND DF >= ? order by MI DESC");
         pstmt.setLong(1, id);
         pstmt.setLong(2, id);
         pstmt.setInt(3, df);
         rset = pstmt.executeQuery();
         
         numFeaturesPositive = 0;
         while (rset.next() && result.size() < amount)
         {
            String term = rset.getString(1);
            int termdf = rset.getInt(2);
            String mi = rset.getString(3);
            int evaluation = rset.getInt(4);
            int score = rset.getInt(5);
            result.add(new TermPreview(term, termdf, mi, evaluation, score));
            
            if (evaluation>0)
               numFeaturesPositive++;
         }
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         
         //==========================================
         
         pstmt = conn.prepareStatement("select distinct term from terms where stem = ? group by term order by count(*) desc");
         PreparedStatement pstmt1 = conn.prepareStatement("select URL From BingoDocuments B, DocumentFeatures F WHERE F.term = ? and B.ID = F.ID AND B.Class_ID in (SELECT Class_ID From Classes Where Name Like (Select Name From Classes WHERE Class_ID = ?) || '%') order by B.SvmScore DESC");
         Iterator it = result.iterator();
         while (it.hasNext())
         {
            TermPreview tp = (TermPreview) it.next();
            pstmt.setString(1, tp.term );
            rset= pstmt.executeQuery();
            int count=0;
            StringBuffer context = new StringBuffer(300);
            while (rset.next() && count < 5)
            {
               context.append(rset.getString(1));
               context.append(", ");
               count++;
            }
            if (context.length() > 2)
            {
               context.deleteCharAt(context.length()-1);
               context.deleteCharAt(context.length()-1);
            }
            rset.close(); rset=null;
            if (count>=5)
               context.append("...");
            tp.setContext(context.toString());
            context=null;
            
            pstmt1.setString(1, tp.term);
            pstmt1.setLong(2, id);
            rset = pstmt1.executeQuery();
            if (rset.next())
            {
               tp.setBestURL(rset.getString(1));
            }
            rset.close(); rset=null;
         }
         pstmt.close(); pstmt=null;
         pstmt1.close(); pstmt1=null;
      }
      catch (Exception e)
      {
         captureError(e);
         return result;
      }
      noError();
      return result;
   }
   
   public static void updateFeatures(ArrayList candidates, long classID)
   {
      if (candidates == null || candidates.size() <= 0)
         return;
      
      if (!verifyConnection())
         return;
      
      try
      {
         // setAllFeatures(classID, 0);
         
         PreparedStatement pstmt = conn.prepareStatement("Update Classfeatures SET Evaluation=? WHERE Term=? AND Class_ID=?");
         Iterator it = candidates.iterator();
         while (it.hasNext())
         {
            TermPreview tmp = (TermPreview)it.next();
            pstmt.setInt(1, tmp.evaluation);
            pstmt.setString(2, tmp.term);
            pstmt.setLong(3, classID);
            pstmt.addBatch();
         }
         pstmt.executeBatch();
         pstmt.close(); pstmt=null;
         conn.commit();
         it=null;
      }
      catch (Exception e)
      {
         captureError(e);
      }
   }
   
   public static void setAllFeatures(long classID, int value)
   {
      if (!verifyConnection())
         return;
      
      try
      {
         PreparedStatement pstmt = conn.prepareStatement("Update Classfeatures SET Evaluation=? WHERE Class_ID=?");
         pstmt.setInt(1, value);
         pstmt.setLong(2, classID);
         pstmt.executeUpdate();
         pstmt.close(); pstmt=null;
         conn.commit();
      }
      catch (Exception e)
      {
         captureError(e);
      }
   }
   
   public ArrayList getWarnings()
   {
      ArrayList result = new ArrayList(50);
      
      if (!verifyConnection())
         return result;
      
      try
      {
         Statement stmt = conn.createStatement();
         ResultSet rset = stmt.executeQuery("SELECT C.Name, C.Class_ID From Classes C WHERE C.Name != 'ROOT/' AND 5 > (SELECT COUNT(*) From ClassFeatures CF WHERE CF.Class_ID = C.Class_ID AND CF.Evaluation = 1 )");
         while (rset.next())
         {
            String class_name = rset.getString(1);
            long class_id = rset.getLong(2);
            StringBuffer tmp = new StringBuffer(300);
            tmp.append("<B>Warning:</B> less than 5 features in ");
            tmp.append("<A href=\"feature_auswahl.jsp?klasse=");
            tmp.append(class_id);
            tmp.append("&df=2\">");
            tmp.append(class_name);
            tmp.append("</A>");
            tmp.append(" are marked as 'positive'");
            result.add(tmp.toString());
            tmp=null;
         }
         rset.close(); rset=null;
         
         rset = stmt.executeQuery("SELECT C.Name, C.Class_ID From Classes C WHERE C.Name != 'ROOT/' AND 0 = (SELECT COUNT(*) From ClassFeatures CF WHERE CF.Class_ID = C.Class_ID AND CF.Evaluation = 0 )");
         while (rset.next())
         {
            String class_name = rset.getString(1);
            long class_id = rset.getLong(2);
            StringBuffer tmp = new StringBuffer(300);
            tmp.append("<B>Warning:</B> all features in ");
            tmp.append("<A href=\"feature_auswahl.jsp?amount=50&klasse=");
            tmp.append(class_id);
            tmp.append("&df=2\">");
            tmp.append(class_name);
            tmp.append("</A>");
            tmp.append(" are marked as 'positive'");
            result.add(tmp.toString());
            tmp=null;
         }
         rset.close(); rset=null;
         
         stmt.close();stmt=null;
      }
      catch (Exception e)
      {
         captureError(e);
      }
      
      return result;
   }
   
   
   public ArrayList getSeemOK()
   {
      ArrayList result = new ArrayList(50);
      
      if (!verifyConnection())
         return result;
      
      try
      {
         Statement stmt = conn.createStatement();
         PreparedStatement pstmt = conn.prepareStatement("SELECT COUNT(*) From ClassFeatures WHERE Class_ID = ? AND Evaluation > 0");
         PreparedStatement pstmt1 = conn.prepareStatement("SELECT COUNT(*) From ClassFeatures WHERE Class_ID = ?");
         ResultSet rset = stmt.executeQuery("SELECT C.Name, C.Class_ID From Classes C WHERE C.Name != 'ROOT/' AND 5 <= (SELECT COUNT(*) From ClassFeatures CF WHERE CF.Class_ID = C.Class_ID AND CF.Evaluation = 1 ) AND 0 < (SELECT COUNT(*) From ClassFeatures CF WHERE CF.Class_ID = C.Class_ID AND CF.Evaluation = 0 )");
         while (rset.next())
         {
            String class_name = rset.getString(1);
            long class_id = rset.getLong(2);
            
            pstmt.setLong(1, class_id);
            ResultSet rset1 = pstmt.executeQuery();
            rset1.next();
            int termcount = rset1.getInt(1);
            rset1.close(); rset1=null;
            
            pstmt1.setLong(1, class_id);
            rset1 = pstmt1.executeQuery();
            rset1.next();
            int termfullcount = rset1.getInt(1);
            rset1.close(); rset1=null;
            
            StringBuffer tmp = new StringBuffer(300);
            tmp.append("<B>OK:</B> ");
            tmp.append(termcount);
            tmp.append(" of ");
            tmp.append(termfullcount);
            tmp.append(" features are positive in ");
            tmp.append("<A href=\"feature_auswahl.jsp?amount=50&klasse=");
            tmp.append(class_id);
            tmp.append("&df=2\">");
            tmp.append(class_name);
            tmp.append("</A>");
            result.add(tmp.toString());
            tmp=null;
         }
         rset.close(); rset=null;
         pstmt.close(); pstmt=null;
         pstmt1.close(); pstmt1=null;
         stmt.close();stmt=null;
      }
      catch (Exception e)
      {
         captureError(e);
      }
      
      return result;
   }
}