package bingo;

import java.util.Vector;
import java.util.Hashtable;

import java.sql.*;
import oracle.jdbc.dbaccess.*;
import oracle.sql.*;

/**
 * Bean fuer "bingo_feed_check_2.jsp:
 * Speichert die Antworten des Users aus der Bewertung in bingo_feed_check.
 */
public class bingo_feed_check_2
{

  /**
   * Oeffnet die DB-Verbindung, fuehrt die Aktualisierungen durch und 
   * schliesst die Verbindung
   * @param dbconn Angabe der Datenbankverbindung
   * @param user Angabe der Benutzernamen fuer DB-Verbindung
   * @param passwort Angabe des Passworts fuer DB-Verbindung
   * @param parameter Vector, der die Details zu allen positiv markierten
   * URLs als Hashtables enthaelt
   */
  public void executeDBQuery(String dbconn, String user, String passwort, Vector parameter)
  {
    this.hadSQLException = false;
    this.errorMessage = "";
    try
    {
      DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
      Connection conn = DriverManager.getConnection(dbconn, user, passwort);
      Statement stmt = conn.createStatement();
      
      Hashtable details = new Hashtable();
      for (int i=0; i < parameter.size(); i++)
      {
        details.clear();
        details = (Hashtable) parameter.elementAt (i);        
        long documentId = ((Long) details.get("ID")).longValue();
        long classOld = ((Long) details.get("Wert_old_class")).longValue();
        long classNew = ((Long) details.get("Wert_new_class")).longValue();
        int result = 0;
        if (classOld == classNew) result=1;    
        
        // Daten fuer diese Klasse loeschen und neu eintragen        
        stmt.addBatch ("delete from feedback where id=' "+ documentId + "'");        
        String query = "insert into feedback (result, class_old, class_new, ID) Values ";
        query += "('"+result+"', '"+classOld+"', '"+classNew+"' , '"+documentId+"')";
        stmt.addBatch (query);
        if (i%20==0 || i==parameter.size()-1)
        {
            stmt.executeBatch ();
            stmt.clearBatch();
        }
      }    

      // Schliessen der DB-Verbindung
      stmt.close();
      conn.close();
    }
    catch (SQLException e)
    {
      this.hadSQLException = true;
      this.errorMessage = e.getMessage();
      e.printStackTrace();
    }
  }

  /**
   * Gibt an, ob bei DB-Abfrage Fehler aufgetreten sind.
   * @return false, wenn Abfrage fehlerfrei
   */
  public boolean getHadSQLException ()
  {
    return this.hadSQLException;
  }

  /**
   * Gibt (falls vorhanden) Fehlermeldung der DB-Abfrage aus.
   * @return Fehlermeldung der DB-Abfrage
   */
  public String getErrorMessage ()
  {
    if (errorMessage.length() != 0)
      return errorMessage;
    else
      return "No ErrorMessage available";
  }


  private boolean hadSQLException = false;
  private String errorMessage = "";


}