package bingo;

import java.sql.*;

import oracle.jdbc.dbaccess.*;
import oracle.sql.*;


/**
 * Bean fuer "bingo_feed_clean.jsp":
 * Loescht Teile des User-Feedbacks.
 */
public class bingo_feed_clean
{
  /**
   * Stellt Verbindung mit DB her, fuehrt die Aktualisierung durch
   * und schliesst die Verbindung.
   * @param dbconn Angabe der Datenbankverbindung
   * @param user Angabe der Benutzernamen fuer DB-Verbindung
   * @param passwort Angabe des Passworts fuer DB-Verbindung
   * @param ziel gibt an, was gemacht werden soll
   */
  public void executeDBQuery(String dbconn, String user, String passwort, String ziel)
  {
    String query = "";
    if (ziel.equals("feedback"))
      query = "delete from feedback";

    try
    {
      if (query.length() > 0)
      {
        DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
        Connection conn = DriverManager.getConnection(dbconn, user, passwort);
        conn.setAutoCommit(true);
        Statement stmt = conn.createStatement();
        stmt.executeQuery(query);
        stmt.close();
        conn.close();
      }
    }
    catch (Exception e)
    {
      this.hadSQLError = true;
      this.errorMessage = e.toString();
      e.printStackTrace();
    }

  }

  /**
    * Gibt an, ob bei DB-Abfrage Fehler aufgetreten sind.
    * @return false, wenn Abfrage fehlerfrei
    */
  public boolean getHadSQLError()
  {
    return this.hadSQLError;
  }

  /**
     * Gibt (falls vorhanden) Fehlermeldung der DB-Abfrage aus.
     * @return Fehlermeldung der DB-Abfrage
     */
  public String getErrorMessage()
  {
    if (errorMessage.length() != 0)
      return errorMessage;
    else
      return "No ErrorMessage available";
  }

  private boolean hadSQLError = false;
  private String errorMessage = "";


}