package bingo;

import java.sql.*;
import oracle.jdbc.dbaccess.*;
import oracle.sql.*;

/**
 * Bean fuer "bingo_feed_settings.jsp":
 * Speichert die in "bingo_feed_admin.jsp" festgelegten Aenderungen der
 * Systemparameter in die DB-Relation feedback_options.
 */
public class bingo_feed_settings
{
  /**
   * Fuehrt die DB-Abfrage durch:
   * Oeffnet die DB, aktualisiert die DB-Einstellungen, schliesst die
   * Verbindung wieder.
   * @param dbconn Angabe der Datenbankverbindung
   * @param user Angabe der Benutzernamen fuer DB-Verbindung
   * @param passwort Angabe des Passworts fuer DB-Verbindung
   * @param url neuer Wert fuer "URL_SELECT"
   * @param others neuer Wert fuer "OTHERS_SELECT"
   * @param score neuer Wert fuer "SCORE_SELECT"
   * @param top neuer Wert fuer "TOP_SELECT"
   */
  public void runDBQuery (String dbconn, String user, String passwort, String url, String others, String score, String top)
  {
    this.hadSQLException = false;
    this.errorMessage = "";
    try
    {
      DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
      Connection conn = DriverManager.getConnection(dbconn, user, passwort);
      conn.setAutoCommit(false);

      Statement stmt = conn.createStatement();
      stmt.executeQuery("delete from feedback_options");      
      String query = "insert into feedback_options (URL_SELECT, OTHERS_SELECT, SCORE_SELECT, TOP_SELECT) ";
      query += "values ('" + url + "', '" + others + "', '" + score + "', '" + top +"')";      
      stmt.executeQuery (query);
      stmt.executeQuery ("commit");

      stmt.close();
      conn.close();
    }
    catch (SQLException e)
    {
      this.hadSQLException = true;
      this.errorMessage = e.getMessage ();
      e.printStackTrace();
    }
  }

  /**
   * Gibt an, ob bei DB-Abfrage Fehler aufgetreten sind.
   * @return false, wenn Abfrage fehlerfrei
   */
  public boolean getHadSQLException ()
  {
    return this.hadSQLException;
  }

  /**
   * Gibt (falls vorhanden) Fehlermeldung der DB-Abfrage aus.
   * @return Fehlermeldung der DB-Abfrage
   */
  public String getErrorMessage ()
  {
    if (errorMessage.length() != 0)
      return errorMessage;
    else
      return "No ErrorMessage available";
  }

  private boolean hadSQLException = false;
  private String errorMessage = "";
}