package schema;

import java.io.*;
import java.util.Enumeration.*;
import java.util.*;
import java.sql.*;
import oracle.jdbc.dbaccess.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.lang.Math.*;


public class SchemaManager
{   
    private SessionBuffer session;
    private Connection conn;
    private Statement stmt;
    private static search.constants Constants = new search.constants();

    public SchemaManager()
    {
      session = SessionBuffer.getInstance(true);
    }
    
    public void createSchema ()
    {
      try
      {  
               
        openConnection();  
        processFile (session.userDir + System.getProperty( "file.separator" ) + "schema" + System.getProperty( "file.separator" ) + "importer.sql");
       // processFile ("importer.sql");
        closeConnection();
        
        storeDescriptor();
        System.out.println("Import has been finished");
      } 
      catch (Exception e)
      {e.printStackTrace();}
    }

  /*
    public void createIndex ()
    {
      try
      {        
        openConnection();  
        processFile (session.userDir + System.getProperty( "file.separator" ) + "index.sql");
        closeConnection();
      } 
      catch (Exception e)
      {e.printStackTrace();}
    }
   */
    
    public void processFile (String myFile) throws Exception
    {
        BufferedReader reader = new BufferedReader (new FileReader(new File(myFile)));
        boolean finished = false;
        
        StringBuffer command = new StringBuffer();
        while (! finished)
        {
          String line = reader.readLine();
          if (line == null)
          {
             if (command.length() > 0) 
             {
               String befehl = command.toString().replaceAll(";","");
               try
               {
                 System.out.println(stmt.executeQuery(befehl).toString());            
               }
               catch (Exception e)
               {
                e.printStackTrace();
               }
               System.out.println (befehl+"\n");
               befehl = null;
               command = null;
             }  
            finished = true;
          }    
          else if (line.trim().length() == 0 || line.startsWith("--"))
          {
             if (command.length() > 0) 
             {
               String befehl = command.toString().replaceAll(";","");
               try{stmt.executeQuery (befehl);}
               catch (Exception e)
               {
                  e.printStackTrace();
               }
               System.out.println (befehl);
               befehl = null;
               command = new StringBuffer();
             }  
          } 
          else 
          {
            line = line.replaceAll ("\\$user\\$", session.defaultUser);
            line = line.replaceAll ("\\$password\\$", session.defaultUserPasswd);
            command.append(line);
            command.append (" ");
          }
        }    

    }
    
    public void DropSchema ()
    {
    
    }
        
    public void dropIndex()
    {
        
    }
    
    void closeConnection()
    {
      if (stmt != null)  
      try{stmt.close();}
      catch (Exception e){}
      stmt=null;
      
      if (conn != null)  
      try{conn.close();}
      catch (Exception e){}
      conn=null;
    }
    
    void openConnection()
    {
      try
      {
        conn= session.getOracleConnection();
        stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
    }
    
/*
    void openAdminConnection()
    {
      try
      {
        conn= session.getAdminOracleConnection();
        stmt = conn.createStatement();
      }
      catch (Exception e)
      {e.printStackTrace();}
    }
*/
    
    void storeDescriptor() throws Exception
    {      
      String s = System.getProperty( "file.separator" );
      //File file = new File (session.userDir + s + "bingo" + s + "data" + s + "accounts.dat");
      File file = new File (Constants.ACCOUNT_PATH);
      try 
      {
       file.createNewFile();
       String descriptor = session.defaultUser + ";" + session.defaultUserPasswd + ";" + session.sHost + ";" + session.sServiceName;
       BufferedWriter to = new BufferedWriter (new FileWriter (file));
       to.write (descriptor);
       to.flush(); 
       to.close();
      }
      catch (Exception e)
      {
        e.printStackTrace();  
      }
    }
    
    public static void main(String[] s)
    {
      new SchemaManager().createSchema();
      System.exit(0);
    }
}
 