/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class Scroll 
{
private error Error;
private Iterator It1 = null;
private Iterator It2 = null;
private Vector URL = new Vector();
private Vector Desc = new Vector();
private boolean status=false;
private String CurrentUrl = "";
private String CurrentDesc = "";
private int counter = 0;
private int     Page = 0;
private int     RproP = 0;
private int     N = 0;
private long    ID = 0;
private String  Adress = null;
    
    public Scroll(error _Error) 
    {
      if (_Error!=null) Error=_Error;  
    }
    
    private void Reset()
    {
      It1=null;
      It2=null;
      URL  = new Vector();
      Desc = new Vector();
      counter = 0;
      status=false;
    }
    
    public void refresh()
    {
      create(Page, RproP, N, ID, Adress);  
    }
    
    public void create(int _Page, int _RproP, int _N, long _ID, String _Adress)
    { 
     counter = -2;  
     Page = _Page;
     RproP = _RproP; 
     N = _N; 
     ID = _ID; 
     Adress = _Adress;
     if (_Adress==null || _Adress=="") status=false;
     else 
     {
      if (_Page<0) Page=0;
      //Error.setMes("Scroll: "+Page+" "+RproP+" "+N+" "+ID+" "+_Adress+" "+Page*RproP);   
      if (N<=0 || RproP<=0 || RproP > N || Page*RproP > N) status = false;
       else
       {
         
        String url =  _Adress+"&RPage="+(Page-1);
        String desc = " PREVIOUS ";
        int from = (Page-1)*RproP+1;; 
        int to = Page*RproP;
        
        URL.add("");
        Desc.add("Results: "+N);
        
        if (Page>0)
         {
           URL.add(url);
           Desc.add(desc);             
         }
        int p = 0;
        for (int i=0; i<N/RproP && i < Page+10 ; i++)
         {
           from = i*RproP+1;
           to = (i+1)*RproP;
           desc = " "+from+" .. "+to+" ";
           url=_Adress+"&RPage="+i;
           URL.add(url);
           Desc.add(desc);
           //Error.setMes("Scroll: "+i+" "+RproP+" "+i*RproP+" "+N/RproP); 
           p=i;
         }
        p++;
        
        if (to<N)
        {
           from = to+1; 
           to+=RproP;
           if (to>N) to=N;
           desc = " "+from+" .. "+to+" ";
           url=_Adress+"&RPage="+p;
           URL.add(url);
           Desc.add(desc);            
        }

        if ((Page+1)*RproP < N)
         {
           //Error.setMes("Scroll: "+Page+" "+RproP+" "+N);   
           url =  _Adress+"&RPage="+(Page+1);
           desc = " NEXT ";              
           URL.add(url);
           Desc.add(desc);             
         }
       It1 = URL.iterator(); 
       It2 = Desc.iterator();
       status=true;
       //Error.setMes("Scroll: "+status);
       }
     }
    }

   public boolean getStatus()
   {
     return status;  
   }
   
   public boolean HasNext()
   {
     if (!status) return false;
     if (It1==null || It2==null) return false;
     if (!It1.hasNext() || ! It2.hasNext()) {Reset(); return false;}
      CurrentUrl  = It1.next().toString();
      CurrentDesc = It2.next().toString();
      counter++;
      return true;
   }
   
   public boolean isCurrentState()
   {  
     if ((counter-1 == Page && Page > 0) || (counter == Page && Page == 0)) return true;
     return false;
   }
   
   public String getUrl()
   {
     if (!status) return null;
     return CurrentUrl;
   }

   public String getDesc()
   {
     if (!status) return null;
     return CurrentDesc;
   }

}
