/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class Session {

private dbconnect DB;
private error Error;
private long ID = 0;
private boolean status = true; 
private String IDStr = null;
private constants C = new constants();

    public Session(dbconnect _DB, error _Error, String HostName, String query) 
    {
      if (_Error!=null) Error=_Error;
      if (_DB!=null) 
      {
       DB=_DB;
       ID = getSessionID();
       IDStr=constants.IDSTR_PREFIX+ID;
       //Error.setMes("Session: "+IDStr);
       //data
       Object[] param = {HostName, new Long(ID), query};
       DB.createSession(IDStr, param);
      }
      else status=false;
    }

    public Session(dbconnect _DB, error _Error, long _ID, String HostName) 
    {
      if (_Error!=null) Error=_Error;
      if (_DB!=null) 
      {
       DB=_DB;
       if (check(_ID)) 
       { 
         ID=_ID;
         IDStr=C.getIDStr(ID);
       } 
       else status=false;
       Error.setMes("Session: "+IDStr+">>"+check(_ID));
      }
      else status=false;
    }
    
    public boolean generateTemp(String query)
    {
      if (!status) return false;
      return DB.searchQuery(IDStr,  query);
    }
    
    private long getSessionID()
    {
     /*
     String query="select max(sessionid) as maxid from "+constants.TEMP_USER;
     Vector V = (Vector)DB.simpleQuery(query,"maxid");
      if (V!=null) 
      {
       Object O = V.elementAt(0);
       if (O==null) return 0;
       long l = (new Long(O.toString())).longValue()+1;
       return l;
      }
      */   
     return new Date().getTime();   
    }
    
    public String getIDStr()
    {
      if (!status) return null;  
      return IDStr;  
    }
    
    public long getID()
    {
      if (!status) return 0;
      return ID;  
    }
    public boolean getStatus()
    {
      return status;  
    }
    
    private boolean check(long ID)
    {
     return  DB.checkSession(ID);  
    }
    
    
}
