/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;

public class Sorter 
{    
private error Error;
private boolean status = false;
private boolean statusBlock = true;
private Iterator It = null;
private Vector StatSort = new Vector();
private constants C = new constants();

  public Sorter(error _Error) 
  {
    Reset();  
    if (_Error!=null) Error=_Error;
    else status=false;
  }
    
  public boolean HasNext()
  {
    if (!status || !statusBlock) return false;
    else
    {
      return It.hasNext();
    }
  }
  public void setStatus(boolean _S)
  {
     statusBlock = _S; 
  }
  public void create(String Query)
  {
    Reset();  
    if (Query==null || Query=="") status=false;
    else
    {
      int b = Query.indexOf("inOrder=");
      int e = Query.indexOf("&",b);
      String prefix="";
      String suffix="";
      if (b==-1) 
       {
        prefix=Query+"&";   
       }
       else
       {
         prefix = Query.substring(0,b);
         if (e>b) suffix = Query.substring(e);         
       }
     int n = C.getOrders().size();
     //Error.setMes("Ordering: "+Query+" Pre "+prefix+" Suf "+suffix);        
     for (int i=0; i<n; i++)
      StatSort.add(prefix+"inOrder="+i+suffix); 
     It = StatSort.iterator();
     status=true;
    }
  }
  
  public String getDesc(String S)
  {
   if (!status) return null;
   if (S==null&& S=="") return null;
   int n = StatSort.indexOf(S);
   if (n==-1) return null;
   return C.getOrders().elementAt(n).toString();
  }
  
  public String getNextScheme()
  {
   if (!status) return null;   
   if (It==null) return null;
   if (!It.hasNext()) return null;
   if (statusBlock) return It.next().toString();
   return null;
  }
  
  public boolean getStatus()
  {
    return status;   
  }
  
  public void Reset()
  {
    It=null;
    status=false;
    statusBlock = true;
    StatSort = new Vector();
  }
}
