/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.util.*;
import java.lang.*;
import java.sql.*;
import oracle.jdbc.dbaccess.*; 
import oracle.jdbc.driver.*;
import oracle.sql.*;
import java.io.*;


public class dbconnect {
    
private error Error;
private OracleConnection Ora = null;
private constants C = new constants();
private PreparedStatement SqlForm;
private ResultSet Rset = null;
private boolean status = true;
private static String host = "";
private static String service = "";
private static String login = "";
private static String pass = "";


public dbconnect(error _Error) 
 { 
   if (_Error!=null) Error=_Error;
    else {;}
   readAccounts();
 } 

 public void readAccounts() 
    {
     java.net.URL u = this.getClass().getClassLoader().getResource(C.ACCOUNT_PATH);
     
     try 
     {
      BufferedReader bf = new BufferedReader( new InputStreamReader( u.openStream() ) );
      String line = bf.readLine();

      while ( line != null ) {
        StringTokenizer st = new StringTokenizer( line, ";" );
        login = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        pass = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        host = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        service = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        line = bf.readLine();
      }
      bf.close();
      Error.setMes(login+pass+host+service);
     }
     catch ( Exception e ) 
     {
       Error.setMes("Can't read account information \n"+e.toString());
     }
   }


public boolean OpenConnect()
{
   String path="";
   try 
   {   
    DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
    path="jdbc:oracle:thin:@(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST="+host+")(PORT=1521)))(CONNECT_DATA=(SERVICE_NAME="+service+")(SERVER=dedicated)))";
    Ora = (OracleConnection)DriverManager.getConnection(path,login,pass);   
    status=true;
   }
    catch(Exception e) 
    {
     Error.setMes("dbconnect constructor S: "+path+"\n"+e.toString());   
     e.printStackTrace();
     status=false;
    }    
   return status;
}

public void CloseConnect()
{
  try 
  {  
   Ora.close();  
  }
  catch (Exception e)
  {
    Error.setMes("CLOSE DBCONNECT ERROR\n"+e.toString());  
  }
  status=false;
}
    
public Collection simpleQuery(String query, String columnname)
{
 if (!status) return null;   
 if (query!=null && query!="" && columnname!=null && columnname!="")  
 {
  try
  { 
   SqlForm = Ora.prepareStatement(query);
   Rset = SqlForm.executeQuery();  
   
   if (!Rset.next()) 
    {
     SqlForm.close(); 
     return null;
    }
   else
   {    
     Vector V = new Vector();
     V.add(Rset.getString(columnname));
     while (Rset.next())
     {
      V.add(Rset.getString(columnname));   
     }
     Rset.close();
     SqlForm.close();
     return V;
   }
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect sQuery error\n"+query+"\n"+columnname+"\n"+e.toString());
   e.printStackTrace();
  }
 }
 else 
 {
  Error.setMes("dbconnect empty query");   
 }
 return null;
}

public Collection getClasses()
 {  
  if (!status) return null;   
  String query = "select distinct(name) as name from "+constants.CLASS_T;
  Collection Classes = simpleQuery(query,"name");
  if (Classes==null) 
   {
    Error.setMes("dbconnect NO CLASSES in DB");
    return null;
   }
  return Classes;
 }
 
public boolean createSession(String IDStr, Object userdata[])
 {   
   if (!status) return false;  
   try
   {
    String query = "insert into "+constants.TEMP_USER+" values(";
    for  (int i=0; i<userdata.length-1; i++) {Object O = userdata[i]; query+="'"+O.toString()+"', ";}
    Object O =userdata[userdata.length-1];
    java.util.Date D = new java.util.Date();
    query+="'"+O.toString()+"', "+D.getTime()+")";
    
    SqlForm = Ora.prepareStatement(query);
    Rset = SqlForm.executeQuery();  
    Rset.close();
    SqlForm.close();
    Ora.commit();
    query="create table "+IDStr+"(ID integer NOT NULL, IDF FLOAT, FOREIGN KEY (ID) REFERENCES "+constants.DOC_T+" ON DELETE CASCADE)";        /*DF FLOAT DEFAULT 0.0000001,*/
    SqlForm = Ora.prepareStatement(query);
    Rset = SqlForm.executeQuery();  
    Rset.close();
    SqlForm.close();
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect: ID ERROR \n"+e.toString());
   e.printStackTrace();
   return false;
  }
  return true;       
 }
 
public boolean searchQuery(String ID, String BaseQuery)
 {    
   if (!status) return false;
   try
   {
    String query="insert into "+ID+" "+BaseQuery;
    SqlForm = Ora.prepareStatement(query);
    Rset = SqlForm.executeQuery(); 
    Rset.close();
    SqlForm.close();
    Ora.commit();
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect: ID ERROR:"+BaseQuery+" \n"+e.toString());
   e.printStackTrace();
   return false;
  }
  return true;  
 }

public Collection orderedQuery(String _query, String IDStr, int Page, int RproP, long GID, String OrderBy)
{
 if (!status) return null;   
 if (_query!=null && _query!="")  
 {
  try
  {
      
   int from = Page*RproP;
   int to = (Page+1)*RproP; 
      
   
   SqlForm = Ora.prepareStatement(_query,  Rset.TYPE_SCROLL_INSENSITIVE, Rset.CONCUR_READ_ONLY);
   Rset = SqlForm.executeQuery(); 
   if (Rset.next())
   {    
    Rset.relative(from-1);
    String query="select D.* from "+constants.DOC_T+" D, "+IDStr+" T where T.id = D.id and (";
    for (int i=from; i<to && Rset.next(); i++)
     {
      query+="T.id="+Rset.getString("id")+" or ";     
     }   
    query=query.substring(0,query.length()-3);
    query+=")"+OrderBy;
    Rset.close();
    SqlForm.close();
  
    //Error.setMes("dbconnect "+query);    
    SqlForm = Ora.prepareStatement(query);
    Rset = SqlForm.executeQuery();  
   
   if (!Rset.next()) 
    {
     SqlForm.close(); 
     return null;
    }
   else
   {   
     Vector V = new Vector();
     String _url =       Rset.getString("URL");
     String _title =     Rset.getString("title");
     String _text =      Rset.getString("text");
     double _size =      Rset.getDouble("docsize"); 
     String _classname = Rset.getString("classname");     
     
     java.util.Date _LastDate = Rset.getDate("LASTDATE");
     long _ID =          Rset.getLong("id");

     if (_title==null || _title=="") _title = constants.DEFAULT_TITLE;

     result_body RB = new result_body(_url, _title, _text, _size/1000, _classname, _ID, _LastDate,  Error, GID);
     if (RB.getStatus()) V.add(RB);
     
     while (Rset.next())
     {
      _url =       Rset.getString("URL");
      _title =     Rset.getString("title");
      _text =      Rset.getString("text");
      _size =      Rset.getDouble("docsize"); 
      _classname = Rset.getString("classname");
      _LastDate =  Rset.getDate("LASTDATE");
      _ID =        Rset.getLong("id");
      
      if (_title==null || _title=="") _title = constants.DEFAULT_TITLE;
      
      RB = new result_body(_url, _title, _text, _size/1000, _classname, _ID, _LastDate, Error, GID);
      if (RB.getStatus()) V.add(RB);
     }
     Rset.close();
     SqlForm.close();
     return V;
    }
   }
   else
   {
     SqlForm.close(); 
     /*
     Vector V = new Vector();
     result_body RB =new result_body("NO MATCHED ANSWER","NO MATCHED ANSWER","",0.0,"",0,null,Error,0);
     V.add(RB); */
     return null;       
   }
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect oQuery error\n"+e.toString());
   e.printStackTrace();
  }
 }
 else 
 {
  Error.setMes("dbconnect empty Oquery");   
 }
 return null;
}

 public int Count(String TABLE)
 {
  if (!status) return -1;   
  String q="select count(*) as num from "+TABLE;
  try
  {
   SqlForm = Ora.prepareStatement(q);
   Rset = SqlForm.executeQuery();  
   int N = 0;
   if (Rset.next()) N = Rset.getInt("num");
   Rset.close();
   SqlForm.close();
   return N;
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect COUNT error\n"+e.toString());
  } 
  return -1;
 }

 public boolean checkSession(long ID)
 {
    if (!status) return false; 
    String query = "select sessionid from "+constants.TEMP_USER+" where sessionid='"+ID+"'";  
    Collection C = simpleQuery(query, "sessionid");
    if (C!=null && C.size()==1) 
      {      
       query ="update "+constants.TEMP_USER+" set time=? where sessionid=?";
       try 
       {
        PreparedStatement temp = Ora.prepareStatement(query);
        temp.setLong(1, new java.util.Date().getTime());
        temp.setLong(2, ID);       
        temp.execute(); 
        temp.close();
        return true;
       }
       catch (Exception e)
       {
        Error.setMes("Seesion problems:"+e.toString());   
       }
      }
    return false;    
 }
 
 public boolean deleteSession()
 {
  if (!status) return false;     
  try
  {   
   java.util.Date D = new java.util.Date();      
   long current_time = D.getTime();  
   String query = "select sessionid from "+constants.TEMP_USER+" where "+current_time+"-time>"+constants.SESSION_TIMEOUT;   
   //Error.setMes("dbconnect "+query);   
   SqlForm = Ora.prepareStatement(query);
   Rset = SqlForm.executeQuery();  
   
   long _ID=0;
   while (Rset.next())
    {
      try
      {
      _ID = Rset.getLong("sessionid");   
      String subQuery = "drop table "+C.getIDStr(_ID);  
      PreparedStatement temp = Ora.prepareStatement(subQuery);
      boolean t = temp.execute(); 
      temp.close();

      subQuery = "insert into "+constants.HISTORY_T+" select host, query, time from "+constants.TEMP_USER+" where sessionid='"+_ID+"'";  
      temp = Ora.prepareStatement(subQuery);
      t = temp.execute(); 
      temp.close();

      subQuery = "delete from "+constants.TEMP_USER+" where sessionid=?";  
      temp = Ora.prepareStatement(subQuery);
      temp.setLong(1, _ID);
      t = temp.execute(); 
      temp.close();
      
      }
      catch (Exception e1) 
      {
        Error.setMes("local delete error\n"+e1.toString());
      }
    }
    Rset.close();
    SqlForm.close();
   
   String query1="insert into "+constants.HISTORY_T+" select host, query, time from "+constants.TEMP_USER+" where "+current_time+"-time>"+constants.SESSION_TIMEOUT;
   //Error.setMes("dbconnect "+query1);
   SqlForm = Ora.prepareStatement(query1);
   SqlForm.execute();
   //Error.setMes("dbconnect "+query1+" "+);  
   SqlForm.close();
   Ora.commit();
   
   
   query = "delete from "+constants.TEMP_USER+" where "+current_time+"-time>"+constants.SESSION_TIMEOUT;   
   SqlForm = Ora.prepareStatement(query);
   SqlForm.execute();
   SqlForm.close();
   Ora.commit();

   return true;
  }
  catch (Exception e)
  {
   Error.setMes("dbconnect Error dQuery \n"+e.toString());
   return false;
  }
 }
 
 public boolean InsertQuery(String query)
 {
   if (!status) return  false;     
   if (query==null || query=="") return false;
   try
   {
     SqlForm = Ora.prepareStatement(query);
     Rset = SqlForm.executeQuery(); 
     Rset.close();
     SqlForm.close();
     Ora.commit();  
     return true;  
   }
   catch (Exception e)
   {
    Error.setErr(constants.INSERTION_ERROR);
    Error.setMes("dbconnect iQuery Error "+query+"\n"+e.toString());
    return false;   
   }
 }
} //END

