/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.util.*;
import java.lang.*;
import bingo.util.*;

public class query_body implements Comparable
{
    
    
private String TERM = new String();
private int TYPE = 0;
private Stemmer S = new Stemmer();

/*
 ! = not_term
 % = wildcard
 [ = right bracket
 ] = left bracket
 _ = AND
 AND = AND
 OR = OR
 | = OR
 domain:www.www.xx/../ = domain
 a..z0..9 = term
**/

 public query_body(String term, boolean TmFt) 
 {
  String _term = term;   
  if (_term=="") {;}
   else 
    if (_term.length()==1)
     {
       switch (_term.charAt(0))
       {
           case '[': {TERM=""; TYPE=constants.LBRACKET;} break;
           case ']': {TERM=""; TYPE=constants.RBRACKET;} break;
           case ' ': {TERM=""; TYPE=constants.AND;} break;
           case '|': {TERM=""; TYPE=constants.OR;} break;   
       }
     }
     else
     {
       if (_term.equals("AND")) {TERM=""; TYPE=constants.AND;}
        else if (_term.equals("OR")) {TERM=""; TYPE=constants.OR;}
         else 
         {
           TERM=term;
           TYPE=constants.TERM;
           if (_term.startsWith("!") || _term.startsWith("-"))
            {
              _term = _term.substring(1);
              TERM = _term;
              TYPE = constants.NOT_TERM;
            }
           if (_term.length()>7&&_term.startsWith("domain:"))
            {
              _term = _term.substring(7);
              TERM = _term;
              if (TYPE==constants.NOT_TERM) TYPE = constants.NOT_DOMAIN;
               else TYPE = constants.DOMAIN;
            } 
           if (_term.length()>3&&_term.endsWith("%"))
            if (TYPE!=constants.DOMAIN&&TYPE!=constants.NOT_DOMAIN)
            { 
              //_term = _term.substring(0,_term.length());
              TERM = _term;
              if (TYPE==constants.NOT_TERM) TYPE = constants.NOT_WILDCARD;
               else TYPE = constants.WILDCARD;                
            }   
            else
            {  
            }    
         }  
       if (!TmFt && (TYPE==constants.TERM || TYPE==constants.NOT_TERM || TYPE==constants.WILDCARD || TYPE==constants.NOT_WILDCARD)) TERM = Stem(TERM); 
     }  
 }
 
 public String Stem(String origin)
 {
   S.add(origin.toCharArray(), origin.length());
   S.stem();
   return S.getResultWord().toLowerCase();
 }
 public int getTYPE()
 {
   return TYPE;
 }
 
 public String getTERM()
 {
   return TERM;
 }
 
 public boolean setTYPE(int type)
 {
  if (type>=3 && type<=6) {TERM=""; TYPE=type;}
   else 
    if (TERM!="") {TYPE=type;}
    if (TYPE==constants.CLASS) TERM = TERM.toUpperCase();
     else return false;
  return true;
 }

 /*IMPORTANT COMMENTS
 priority in group
 (query without brackets one group)
 
 1. inClass
 2. domain
 3. not domain
 4. not term
 5. not wildcard
 6. term
 7. wildcard
 */ 
 public int compareTo (Object o)
 {
  int _TYPE = 0;
  if (o!=null) _TYPE = ((query_body)o).getTYPE();
   else return 0;
  int t=0;
  switch (TYPE)
  {
      case constants.CLASS:         t=1; break;
      case constants.DOMAIN:        t=2; break;
      case constants.NOT_DOMAIN:    t=3; break;
      case constants.NOT_TERM:      t=4; break;
      case constants.NOT_WILDCARD:  t=5; break;
      case constants.TERM:          t=6; break;
      case constants.WILDCARD:      t=7; break;
      default:                      t=8;
  }
  switch (_TYPE)
  {
      case constants.CLASS:         t-=1; break;
      case constants.DOMAIN:        t-=2; break;
      case constants.NOT_DOMAIN:    t-=3; break;
      case constants.NOT_TERM:      t-=4; break;
      case constants.NOT_WILDCARD:  t-=5; break;
      case constants.TERM:          t-=6; break;
      case constants.WILDCARD:      t-=7; break;
      default:                      t-=8;
  }  
  
  if (t<=0) return -1;
   else if (t>0) return 1;
  return 0;   
 }
}
