/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.util.*;
import java.lang.*;

public class query_builder {

private error Error;
private boolean P = false;
private String Prefix = " = ";
private String notPrefix = "!=";
private boolean first_ranking = true;
private String BASE_TABLE = null;
// Term or Features; default features (false)
private boolean TmFt = false;
private boolean valid;
private String DOC_T = constants.DOC_T;
private boolean first_notterm = true;
private String Result = new String();
private boolean first_domain = true;
private boolean first_notdomain = true;

  public query_builder(error _R) 
  {
    if (_R!=null) Error=_R;
    if (TmFt) BASE_TABLE = constants.TERM_T;
     else BASE_TABLE = constants.FEATURE_T;
    DOC_T = constants.DOC_T;
  }
/*
 priority in group
 (query without brackets one group)
 
 1. inClass
 2. domain
 3. not domain
 4. not term
 5. not wildcard
 6. term
 7. wildcard
 */
  
  private String subQuery(query_body QB, String TABLE)
  {
   String temp = TABLE;
   String VARIABLE = QB.getTERM().toLowerCase();
   String _Prefix=" = ";
   //Error.setMes("builder query debugger EXCATLY2: "+TABLE);   
   if (P && (QB.getTYPE()==constants.NOT_TERM||QB.getTYPE()==constants.TERM) && TmFt) 
    {
     VARIABLE+="%";
     _Prefix = " like ";
    }
   switch (QB.getTYPE())
   {
       case constants.NOT_TERM:     temp=NotTerm(TABLE, VARIABLE, " = "); break; //temp="select * from ("+TABLE+") where id not in (select id from ("+TABLE+") where  term "+Prefix+" '"+VARIABLE+"')"; break;
       case constants.NOT_WILDCARD: temp=NotTerm(TABLE, VARIABLE, " like "); break;//temp="select * from ("+TABLE+") where id not in (select distinct(id) from ("+TABLE+") where term like '"+VARIABLE+"%')"; break;
       case constants.CLASS:        temp="(select id, hostname from "+TABLE+" where lower(classname) like '"+VARIABLE+"%')"; break;
       case constants.DOMAIN:       temp=Domain(TABLE, VARIABLE); break;
       case constants.NOT_DOMAIN:   temp=NotDomain(TABLE, VARIABLE); break;
       case constants.TERM:         temp=Ranking_term(constants.TERM,TABLE,VARIABLE, " = ", "or"); break;
       case constants.WILDCARD:     temp=Ranking_term(constants.WILDCARD,TABLE,VARIABLE, _Prefix, "or"); break;
       default: valid = false; 
   }
   return temp;
  }
 
  private String Domain(String TABLE, String VARIABLE)
  {
   String temp = new String();   
   if (first_domain)
     {
       temp="select id from "+TABLE+" where (hostname like '%"+VARIABLE+"')";
       first_domain=false;
     }
    else
     {   
      temp=temp.substring(0,temp.length()-1);   
      temp=TABLE+" or hostname like '%"+VARIABLE+"')";
     }
   return temp;    
  }

  private String NotDomain(String TABLE, String VARIABLE)
  {
   String temp = new String();   
   if (first_notdomain && first_domain)
     {
       temp="select id from "+TABLE+" where hostname not like '%"+VARIABLE+"' ";
       first_domain=false;
     }
    else
     {   
      if (first_domain) { temp=TABLE+") and hostname not like '%"+VARIABLE+"'"; first_domain=false; }
       else temp=TABLE+" and hostname not like '%"+VARIABLE+"'";
     }
   return temp;    
  }
  
  
  private String Ranking_term(int TYPE, String TABLE, String VARIABLE,String  _Prefix, String _ANDOR)
  {   
   String temp = new String();
   String ANDOR = _ANDOR;
   if (first_ranking)
     {
      temp="select id, count(tf_idf)*sum(tf_idf) as IDF from "+TABLE+" where term "+_Prefix+" '"+VARIABLE+"'";
      first_ranking=false;
     }
    else
     {
      if (!ANDOR.equalsIgnoreCase("and") && !ANDOR.equalsIgnoreCase("or")) ANDOR = "and";  
      //temp=temp.substring(0,temp.length()-2);            
      temp=TABLE+" "+ANDOR+" term "+_Prefix+" '"+VARIABLE+"'";
     }
   valid=false;
   return temp;    
  }
  
 
  private String NotTerm(String TABLE, String VARIABLE, String _Prefix)
  {
    String temp="";  
    if (first_notterm)
     {
      temp="(select * from ("+TABLE+") where id not in (select id from "+BASE_TABLE+" where  term "+_Prefix+" '"+VARIABLE+"' ";   
      first_notterm=false;
     }
    else
     {
      temp=TABLE+" or term "+_Prefix+" '"+VARIABLE+"' ";   
     }
    return temp;
  }
  
  public void setIDSearch(String IDStr)
  {
    if (IDStr!=null && IDStr!="")  
    {
     BASE_TABLE = "(select D.* from "+BASE_TABLE+" D, "+IDStr+" T where D.id=T.id)";   
     DOC_T = "(select D.* from "+DOC_T+" D, "+IDStr+" T where D.id=T.id)";   
    }
    else
       setFullSearch();
  }
  
  public void setFullSearch()
  {
    if (TmFt) BASE_TABLE = constants.TERM_T;
     else BASE_TABLE = constants.FEATURE_T;
    DOC_T = constants.DOC_T;  
  }
  
  public void Reset()
  {
    first_ranking = true; 
    first_notterm = true;
    first_domain =  true;
    first_notdomain = true;
  }
  
  public void build(Collection Query)
  {
    if (Query!=null)
     {
      Reset();   
      TreeSet T = new TreeSet(Query); //sort by priority
      Iterator It = T.iterator();
      
      String TABLE = new String() ;
      int group = 0;
      while (It.hasNext())
       {
        Object O = It.next();
        query_body QB = (query_body)O;
        switch (QB.getTYPE())
        {
          case constants.NOT_TERM:     if (group==0) {TABLE=BASE_TABLE;} else if (group==1) {TABLE="select T.* from "+BASE_TABLE+" T, ("+TABLE+") D where D.id=T.id";} group=2; break;
          case constants.NOT_WILDCARD: if (group==0) {TABLE=BASE_TABLE;} else if (group==1) {TABLE="select T.* from "+BASE_TABLE+" T, ("+TABLE+") D where D.id=T.id";} group=2; break;
          case constants.CLASS:        if (group==0) {TABLE=DOC_T; group=1;} break;
          case constants.DOMAIN:       if (group==0) {TABLE=DOC_T; group=1;} break;
          case constants.NOT_DOMAIN:   if (group==0) {TABLE=DOC_T; group=1;} break;
          case constants.TERM:         if (group==0) {TABLE=BASE_TABLE;} else if (group==1) {TABLE = "(select D.* from "+BASE_TABLE+" D, ("+TABLE+") T where D.id=T.id)";} else if (group==2) TABLE+="))"; group=3; break;
          case constants.WILDCARD:     if (group==0) {TABLE=BASE_TABLE;} else if (group==1) {TABLE = "(select D.* from "+BASE_TABLE+" D, ("+TABLE+") T where D.id=T.id)";} else if (group==2) TABLE+="))"; group=3; break;
          default: valid = false;
        } 
        TABLE=subQuery(QB, TABLE); 
        //Error.setMes("builder query debugger EXCATLY: "+TABLE+"\ntype "+QB.getTYPE());
       }  
      if (group==1) TABLE="(select T.* from "+BASE_TABLE+" T, ("+TABLE+") D where D.id=T.id)";
      if (group==2) TABLE+="))";
      if (first_ranking) TABLE = "select id, sum(tf_idf) as idf from "+TABLE;
      //if (!TmFt) 
      TABLE = "("+TABLE+" group by id)";
      //TABLE = " select id, idf from "+TABLE;
      //ordering by autoscheme 
      TABLE = "select id, idf from (select D.id, idf, authscore*idf as auto from "+constants.DOC_T+" D, "+TABLE+" T where D.id=T.id order by auto desc) where rownum<"+constants.MAX_RES_NUM;
      Result = TABLE;    
    }
    else
     {
      Error.setErr(constants.INTERNAL_PROGRAMM_ERROR);  
      Result = null;
     }
  }
   
  public void setPrefix(boolean _P)
  {
   P = _P;
   if (P) {Prefix = " like "; notPrefix = " not like ";}
    else  {Prefix = "=";  notPrefix="!=";}
  }
  
  public String getResult()
  {
    return Result;  
  }
  
  public void setTerm()
  {
   TmFt=true;
   BASE_TABLE = constants.TERM_T;
  }
  
  public void setFeatures()
  {
   TmFt=false;
   BASE_TABLE = constants.FEATURE_T;
  }
  
  public String orderedQuery(String _inOrder, String BASE_QUERY)
  {
    String inOrder = OrderBy(_inOrder);
    String query = "select T.id from "+BASE_QUERY+" T";
    if (inOrder!="") query+=", "+constants.DOC_T+" D where D.id=T.id "+inOrder;   
    //Error.setMes("OredQ: "+query);
    return query;
  }
  
  public String OrderBy(String _inOrder)
  {
    String inOrder = ""; 
    if (_inOrder==null || _inOrder=="" || _inOrder.equals(constants.DEFAULT_ORDER)) inOrder = " suck me";
     else if (_inOrder.equals(constants.AUTH_ORDER)) {inOrder = " order by authscore desc";}
      else if (_inOrder.equals(constants.HUB_ORDER)) { inOrder = " order by hubscore desc";}
       else if (_inOrder.equals(constants.TFIDF_ORDER)) { inOrder = " order by idf desc";}
        else if (_inOrder.equals(constants.DATE_ORDER)) { inOrder = " order by lastdate desc";}
    return inOrder;   
  }
  
  public String AdvancedQuery(String IDStr, int Page, int RproP)
  {     
      return "select id from "+IDStr;  
  }
  
  public String simQuery(String BASE, long IDD)
  {
    if (BASE==null || BASE=="" || IDD==0) return null;  
    String temp = "select * from (select id, count(idd.term)*sum(id.idf*idd.idf) as idf from (select term, tf_idf as idf from "+constants.FEATURE_T+" where id = "+IDD+") idd, (select id.id, tf_idf as idf, term from "+BASE+" id, "+constants.FEATURE_T+" F where F.id=id.id) id where id.term=idd.term group by id order by idf desc) where rownum<"+constants.MAX_RES_NUM;  
    return temp;
  }
  
  public String neighborQuery(long IDD)
  {
    if (IDD==0) return null;  
    String temp = "select * from (select T.id as id, idf from (select link_id as id, count(link_id) as idf from ((select LINK_ID from links where id="+IDD+") union all (select id as link_id from links where link_id="+IDD+")) group by link_id order by idf desc) T, "+DOC_T+" D where T.id=D.id) where rownum<"+constants.MAX_RES_NUM;
    return temp;
  }
    
}
