/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.lang.*;
import java.util.*;


public class query_executor
{
   public static String myQuery;
   private dbconnect DB;
   public error Error;
   private query_parser Parser;
   private Vector query_vector;
   private debugger Debugger;
   private String TF = new String();
   private boolean TmFt = false;
   private String inClass = constants.DEFAULT_CLASS;
   private int RproP = constants.RESULTS_PRO_PAGE;
   private String inOrder = constants.DEFAULT_ORDER;
   private boolean prefix = false;
   private long searchIn = 0;
   private String queryStr = new String();
   private boolean TFchecked =false;
   private long ID = 0;
   private int RPage = 0;
   private Session session;
   private String compositQuery = new String();
   private String UserHost = "";
   private Vector ORDERS;
   private constants C = new constants();
   boolean mistake = true;
   boolean SIM = false;
   boolean Neighbor = false;
   private Spider spider;
   long IDD = 0;
   
   
   public Sorter StaticSorter =  null;
   public Scroll scroll       =  null;
   public Result result       =  null;
   
   private query_builder Q_Builder;
   
   public query_executor()
   {
      Debugger = new debugger(constants.LOG_PATH);
      Error = new error(Debugger);
      DB = new dbconnect(Error);
      Parser = new query_parser(Error);
      Q_Builder = new query_builder(Error);
      spider = new Spider(Error);
      ORDERS = C.getOrders();
   }
   
   public void execute()
   {
      DB.OpenConnect();
      Error.setMes("querystr "+queryStr);
      if (queryStr!=null && queryStr.length()>1)
      {
         if (ID==0)
         {
            //PARSE QUERY
            Parser.setTmFt(TmFt);
            String temp = spider.checkData(queryStr);
            query_vector = Parser.parse(temp);
            
            if (inClass!=null&&inClass!=""&&!inClass.equals(constants.DEFAULT_CLASS))
            {
               query_body QB_temp = new query_body(inClass, TmFt);
               QB_temp.setTYPE(constants.CLASS);
               query_vector.add(QB_temp);
            }
            
            //BUILD FIRST QUERY (id, idf table)
            if (TmFt) Q_Builder.setTerm();
            else Q_Builder.setFeatures();
            searchIn();
            Q_Builder.build(query_vector);
            String temp_query = Q_Builder.getResult();
            
            
            Error.setMes("Query to be evaluted \n"+temp_query);
            //CREATE SESSION
            session = new Session(DB,Error,UserHost, compositQuery);
            session.generateTemp(temp_query);
         }
         else
         {
            session = new Session(DB,Error,ID,UserHost);
         } //IF ID EXIST (<> 0)
         
         if (session.getStatus())
         {
            String IDStr = session.getIDStr();
            
            //CREATE ORDERED QUERY
            String temp_query=Q_Builder.orderedQuery(inOrder, IDStr);
            myQuery = temp_query;
            
            //PAGING
            FinalExecution("Main",temp_query);
            if (result.getStatus())
            {
               
               StaticSorter = new Sorter(Error);
               StaticSorter.create(createComQ(compositQuery,session.getID()));
               StaticSorter.setStatus(false);
               StaticSorter.setStatus(true);
            }
         }
         else
            if (mistake)
            {
               mistake=false;
               ID=0;
               Debugger.put("executor start again");
               execute();
            }
            else
            {
               Error.setMes("executor BAD VERY BAD MESSAGE");
            }
      } //IF QUERYSTR EXIST END QUERYSTR
      else
         if (SIM && IDD!=0)
         {
            String temp_query = "";
            if (ID!=0)
            {
               session = new Session(DB, Error, ID, UserHost);
               if (session.getStatus())
               {
                  temp_query=Q_Builder.simQuery(session.getIDStr(),IDD);
                  session = new Session(DB,Error,UserHost, compositQuery);
               }
               else
               {
                  temp_query=Q_Builder.simQuery(constants.DOC_T,IDD);
                  session = new Session(DB,Error,UserHost, compositQuery);
               }
               session.generateTemp(temp_query);
            }
            else
            {
               temp_query=Q_Builder.simQuery(constants.DOC_T,IDD);
               session = new Session(DB,Error,UserHost, compositQuery);
               session.generateTemp(temp_query);
            }
            
            FinalExecution("Sim","");
         }   //END SIM
         else
            if (Neighbor && IDD!=0)
            {
               String temp = Q_Builder.neighborQuery(IDD);
               session = new Session(DB,Error,UserHost, compositQuery);
               session.generateTemp(temp);
               FinalExecution("Neighbor","");
            }// END Neighbor
            else
               if (ID!=0 & RPage!=0)
               {
                  session = new Session(DB, Error, ID, UserHost);
                  FinalExecution("IDEx","");
               }//END ID
   }
   
   
   public void FinalExecution(String Q, String OrderQ)
   {
      if (session.getStatus())
      {
         String IDStr = session.getIDStr();
         String finalQuery = Q_Builder.AdvancedQuery(IDStr, RPage, RproP);
         if (OrderQ!=null && OrderQ!="") finalQuery = OrderQ;
         Debugger.put("FINAL QUERY "+Q+" : "+finalQuery);
         
         long LID = session.getID();
         String RComQ = createComQ(compositQuery,LID);
         String OrderBy=Q_Builder.OrderBy(inOrder);
         result = new Result(Error, DB.orderedQuery(finalQuery, IDStr, RPage, RproP, LID, OrderBy));
         if (result.getStatus())
         {
            scroll = new Scroll(Error);
            int N = DB.Count(IDStr);
            scroll.create(RPage, RproP, N, LID, RComQ);
            result.setStartNum(RPage*RproP);
         }
      }
   }
   
   //***********************************INPUT OUTPUT
   
   public void Reset()
   {
      compositQuery=constants.BASE_ADRESS;
      queryStr="";
      TF="";
      TmFt = false;
      prefix=false;
      inClass=constants.DEFAULT_CLASS;
      TFchecked=false;
      inOrder = constants.DEFAULT_ORDER;
      RPage=0;
      ID=0;
      inOrder="";
      UserHost="";
      mistake = true;
      SIM = false;
      Neighbor = false;
      IDD = 0;
      DB.CloseConnect();
      constants.get_killer();
      Debugger.put("END executor: Reset()\n");
   }
   
   
   public void setqueryStr(String x)
   {
      if (x==null || x=="") Error.setErr(constants.EMPTY_QUERY);
      else
      {
         queryStr=x;
         Debugger.put("executor "+queryStr);
      }
   }
   
   public void setTF(String x)
   {
      TF=x;
      if (TF.equals("term")) TmFt = true;
      else TmFt = false;
      //Debugger.put(" executor "+TF);
   }
   
   public void setsearchIn(String x)
   {
      if (x!="")
      {
         Long I = new Long(x);
         if (I!=null) searchIn=I.longValue();
         else
         {Error.setMes("executor: BAD ID FORMAT"); searchIn=0;}
      }
   }
   
   public void setinClass(String x)
   {
      inClass=x;
      //Debugger.put("executor "+inClass);
   }
   
   public void setID(String x)
   {
      if (x!="")
      {
         //Debugger.put("Executor ID: "+x);
         Long I = new Long(x);
         if (I!=null) ID=I.longValue();
         else
         {Error.setMes("executor: BAD ID FORMAT"); ID=0;}
      }
   }
   
   public void setIDD(String x)
   {
      if (x!="")
      {
         Long I = new Long(x);
         if (I!=null) IDD=I.longValue();
         else
         {Error.setMes("executor: BAD ID FORMAT"); IDD=0;}
         Debugger.put("Executor IDD: "+x+" "+IDD);
      }
   }
   
   public void setRPage(String x)
   {
      if (x!="")
      {
         Integer I = new Integer(x);
         if (I!=null) RPage = I.intValue();
         //Debugger.put("setpage: "+RPage);
      }
   }
   
   public void setrequest(String Query, String RemoteHost)
   {
      compositQuery=constants.BASE_ADRESS+"?"+Query;
      int n = compositQuery.indexOf("&id");
      if (n>0) compositQuery=compositQuery.substring(0,n);
      UserHost = RemoteHost;
      Debugger.put("Request :"+Query+" "+RemoteHost);
   }
   
   public void setSIM(String x)
   {
      if (x.equals("SIM")) SIM = true;
      else SIM = false;
      Debugger.put("exex: Sim"+x);
   }
   
   public void setinOrder(String x)
   {
      if (x!="")
      {
         Integer I = new Integer(x);
         inOrder=ORDERS.elementAt(I.intValue()).toString();
      }
      //Debugger.put("executor "+inOrder);
   }
   
   public void setNEIGHBOR(String x)
   {
      if (x.equals("YES")) Neighbor = true;
      else Neighbor = false;
      Debugger.put("executor Neighbor"+Neighbor);
   }
   
   public String getTF(int type)
   {
      if (!TFchecked)
      {
         if ((TmFt && type == 1)||(!TmFt && type ==0 ))
         {
            TFchecked=true;
            return "checked";
         }
         else return "";
      }
      return "";
   }
   
   private Iterator It = null;
   
   public boolean hasnextClass()
   {
      if (It==null)
      {
         Collection C = DB.getClasses();
         if (C == null)
            return false;
         
         C.add(constants.DEFAULT_CLASS);
         It = C.iterator();
      }
      if (It.hasNext()) return true;
      else It=null;
      return false;
   }
   
   public String nextClass()
   {
      boolean b = true;
      if (It==null) b = hasnextClass();
      if (b) return It.next().toString();
      else It=null;
      return null;
   }
   
   public String getSelectedClass(String ClassName)
   {
      if (inClass!=null && inClass.equals(ClassName)) return "selected";
      return "";
   }
   
   private Iterator OrIt;
   
   public boolean hasnextOrder()
   {
      if (OrIt==null)
      {
         OrIt = ORDERS.iterator();
      }
      if (OrIt.hasNext()) return true;
      else OrIt=null;
      return false;
   }
   
   public String createComQ(String Q, long _ID)
   {
      if (Q==null) return null;
      String temp = Q;
      temp = extractSubString(temp, "&ID=", "&");
      temp = extractSubString(temp, "&searchIn=", "&");
      temp = extractSubString(temp, "&IDD=", "&");
      temp = extractSubString(temp, "?SIM=", "&");
      temp = extractSubString(temp, "&RPage", "&");
      if (temp.endsWith(constants.BASE_ADRESS)) temp+="?ID="+_ID;
      else temp+="&ID="+_ID;
      Debugger.put("createCQ: "+Q);
      return temp;
      
   }
   
   private String extractSubString(String main, String Pre, String Suf)
   {
      if (main==null || Pre==null || Suf==null) return null;
      int b = main.indexOf(Pre);
      int e = main.indexOf(Suf,b);
      String temp = main;
      if (b!=-1)
      {
         temp = main.substring(0,b);
         if (e>b)
            temp+=main.substring(e-1);
      }
      return temp;
   }
   
   public String OrderValue(String Order)
   {
      if (Order==null || Order == "") return "-1";
      int t = ORDERS.indexOf(Order);
      return ""+t;
   }
   
   public String getqueryStr()
   {
      return queryStr;
   }
   
   public String getFilePath()
   {
      constants C = new constants();
      java.net.URL u = this.getClass().getClassLoader().getResource(C.ACCOUNT_PATH);
      return u.toString();
   }
   
   public String nextOrder()
   {
      boolean b = true;
      if (OrIt==null) b = hasnextClass();
      if (b) return OrIt.next().toString();
      else OrIt=null;
      return null;
   }
   
   public String getSelectedOrder(String Ordering)
   {
      if (inOrder!=null && inOrder.equals(Ordering)) return "selected";
      return "";
   }
   
   public String getID()
   {
      if (session!=null && session.getStatus())
         return ""+session.getID();
      return null;
   }
   
   public boolean searchIn()
   {
      if (searchIn!=0)
      {
         Session S = new Session(DB, Error, searchIn, UserHost);
         if (!S.getStatus()) return false;
         Q_Builder.setIDSearch(S.getIDStr());
         Debugger.put("searchIn: "+searchIn);
         return true;
      }
      return false;
   }
   
}
