/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */

package search;

import java.util.*;
import java.lang.*;
import java.io.*;
import java.net.*;

public class testThread implements Runnable
{
private dbconnect DB;
private error Error;
private Vector terms;
private boolean status = true;
private Date D = new Date();
    
    public testThread(error _Error, Vector V) 
    {
     Error=_Error;
     DB = new dbconnect(Error);
     if (V==null) {status=false; Error.setMes("testThread ERROR empty terms vector");}
      else terms = V; 
    }
    
    public void run() 
    {  
      status=DB.OpenConnect();  
      if (status)
      {
        Error.setMes("Thread start "+D.getTime());  
        Iterator It = terms.iterator();
         try {synchronized (this) {this.wait(500);} }
          catch(Exception e) {Error.setMes("CANT'T WAIT"+e.toString());}
        while (It.hasNext()&&status)
         {
           try
           {
            Object O = It.next();
            String url = createRequest(O);   
            synchronized (this) {this.wait(200);}    
            URL U = new URL(url);
            Date D1 = new Date();
            HttpURLConnection HUC = (HttpURLConnection)U.openConnection();
            if (HUC.getResponseCode()==200)
             {
               InputStream IS = HUC.getInputStream();
               InputStreamReader BF = new InputStreamReader(IS);
               BF.close();
               IS.close();
               Date D2 = new Date();
               ADDtoDB(url, D1.getTime(), D2.getTime());
             }

           }
           catch (Exception e)
           {
            status=false;   
            synchronized (this) {this.notify();}
            Error.setMes("testThread connection\n"+e.toString());   
           }
         }
      }
     status=false;
     synchronized (this) {this.notify();}
     DB.CloseConnect();
     Error.setMes("Thread stop "+D.getTime()); 
    }
    
    public boolean getStatus()
    {
     return status;   
    }
    
    private String createRequest(Object term)
    {
     String term1 = term.toString();
     String basePrefix  = "http://havana.cs.uni-sb.de:8090/lekim/jsp/search/index.jsp?queryStr=";
     String baseSuffix  = "&TF=feature&inClass=ALL&inOrder=0";
     String temp = basePrefix+term1+baseSuffix;
     return temp;
    }
    
    
    private void ADDtoDB(String url, long d1, long d2)
    {
       String query = "insert into TestResults values('"+url+"', "+d1+", "+d2+")";
       if (!DB.InsertQuery(query)) status=false;
    }
}
