drop table SEEV_FEATURE_CLASS_temp 

CREATE TABLE SEEV_FEATURE_CLASS_temp
(
    KEY               varchar2(200)  NOT NULL,
    VALUE             number         DEFAULT 0 ,
    DOCID             integer        NOT NULL,
    FOREIGN KEY (DOCID) REFERENCES SEEV_Documents
      ON DELETE CASCADE
);

drop seef_feature_class_temp_3;

CREATE TABLE SEEV_FEATURE_CLASS_temp_3
(
    N number DEFAULT 1
);

insert into SEEV_FEATURE_CLASS_temp_3 
select count(docid) from seev_documents

insert into seev_feature_class_temp (key, value, docid)
select /*+ ALL_ROWS */ T1.term as key, log(2, N/T2.value)*T1.tf/T3.value, T1.id as docid from SEEV_DOCUMENTS t0, DOCUMENTFEATURES T1, SEEV_FEATURE_CLASS_temp_idf T2, SEEV_FEATURE_CLASS_temp_maxtf T3, SEEV_FEATURE_CLASS_temp_3
where t0.docid = t1.id and T1.id = T3.docid and t0.docid = t3.docid and T1.term = T2.key

commit;

drop table seev_feature_class_temp_idf;

drop table seev_feature_class_temp_maxtf;

drop table SEEV_FEATURE_CLASS_temp_2;

CREATE TABLE SEEV_FEATURE_CLASS_temp_2
(
    MAX_VALUE number DEFAULT 1
);

insert into SEEV_FEATURE_CLASS_temp_2
select max(value) as MAX_VALUE from SEEV_FEATURE_CLASS_temp;

commit;

insert into SEEV_FEATURE_CLASS_0
select key, value/max_value, docid from SEEV_FEATURE_CLASS_temp, SEEV_FEATURE_CLASS_temp_2   

commit;

drop table SEEV_FEATURE_CLASS_temp;

drop table SEEV_FEATURE_CLASS_temp_2;

--- authority score

insert into SEEV_FEATURE_CLASS_1
select ' ', AUTHSCORE/max_score as value, DOCID from SEEV_DOCUMENTS, (select max(authscore) as max_score from Seev_documents)

--- classes with SVM score

insert into SEEV_FEATURE_CLASS_2
select classname, c.svmscore/max_value as value, docid from seev_documents s, crawldocuments c, (select max(svmscore) max_value from crawldocuments)
where s.docid = c.id and c.svmscore > 0.0001

commit;

insert into SEEV_FEATURE_CLASS_2
select classname, 0.0001, docid from seev_documents s, crawldocuments c, (select max(svmscore) max_value from crawldocuments)
where s.docid = c.id and c.svmscore <= 0.0001

commit;

--- date score
insert into SEEV_FEATURE_CLASS_3
select TO_CHAR(lastdate) as key, MONTHS_BETWEEN(lastdate, MN)/MONTHS_BETWEEN(Mx,Mn) as value, docid from 
  seev_documents, 
  (select max(lastdate) as MX, min(lastdate) as MN from seev_documents)

commit;

create index SEEV_FEATURE_CLASS_0_key on SEEV_FEATURE_CLASS_0 (key);

create index SEEV_FEATURE_CLASS_1_key on SEEV_FEATURE_CLASS_1 (key);

create index SEEV_FEATURE_CLASS_2_key on SEEV_FEATURE_CLASS_2 (key);

create index SEEV_FEATURE_CLASS_3_key on SEEV_FEATURE_CLASS_3 (key);

create index SEEV_FEATURE_CLASS_0_key_id on SEEV_FEATURE_CLASS_0 (key, docid);

create index SEEV_FEATURE_CLASS_1_key_id on SEEV_FEATURE_CLASS_1 (key, docid);

create index SEEV_FEATURE_CLASS_2_key_id on SEEV_FEATURE_CLASS_2 (key, docid);

create index SEEV_FEATURE_CLASS_3_key_id on SEEV_FEATURE_CLASS_3 (key, docid);

commit;


