package search;

import java.lang.*;
import java.util.*;

public class Constants  
{
  //standart error message's codes
  public static final int   NO_ERROR = 0; 
  public static final int   EMPTY_QUERY = 1;  
  public static final int   NO_DB_CONNECT = 2;  
  public static final int   INTERNAL_DB_ERROR = 3;
  public static final int   QUERY_BAD_FORMAT = 4;
  public static final int   INTERNAL_PROGRAMM_ERROR = 5;
  public static final int   KILLER_DOWN = 6; 
  public static final int   INSERTION_ERROR = 7;
  
  //feature classes 0..NF-1 (0..100 reserved) 
  public static final int   TERM        = 0;
  public static final int   AUTHORITY   = 1;
  public static final int   CLASS       = 2;
  public static final int   DATE        = 3;
  //feature classes 1..NF (1..100 reserved)
  
  public static final boolean[] ISKEY = {true, false, false, false, false, false};
  public static final int      GLOBAL_NF = 6;

  public static final int   NOT_TERM = 101;  
  public static final int   WILDCARD = 102;
  public static final int   NOT_WILDCARD = 103; 
  
  public static final int   RBRACKET = 166;  
  public static final int   LBRACKET = 199;
  public static final int   AND = 115;
  public static final int   OR =  151; 
  
  public static final int   DOMAIN = 7;
  public static final int   NOT_DOMAIN = -7; 
  
  //tuning parameters
  public static final String    DEFAULT_CLASS="ALL";
  public static final int       RESULTS_PRO_PAGE = 25;
  public static final int       MAX_RES_NUM = 2000;
  public static final int       URL_RES_LEN = 100;
  public static final long      SESSION_TIMEOUT = 18000000; //in ms
  
  public static final String  NEGATIV_FEEDBACK = "negativ";
  public static final String  POSITIV_FEEDBACK = "positiv";
  
  public static final int  NEGATIV = -1; 
  public static final int  POSITIV = 1;
  public static final int  NEUTRAL = 0;
  
  //tablespace
  public static final String DOCUMENTS_TABLE        = "seev_documents";
  public static final String CLASS_TABLE            = "seev_classes";
  public static final String TEMP_USER_TABLE        = "seev_temp_user";
  public static final String HISTORY_TABLE          = "seev_history_temp_user";
  public static final String SESSION_PREFIX         = "seev_session";
  public static final String FEATURE_NAME_PREFIX    = "seev_feature_class_";
  public static final String FEEDBACK_TABLE         = "seev_feedback";
  public static final String FEEDBACK_DOCS_TABLE    = "seev_feedback_docs";
  public static final String PROFILE_TABLE          = "seev_profile";
  public static final String DISTINCT_PROFILE_TABLE = "seev_distinct_profile";
  public static final String GLOBAL_PROFILE_TABLE   = "seev_global_profile";    
  public static final String USER_TABLE             = "seev_users";    
  public static final String FEEDBACK_BLOB_TABLE    = "seev_feedback_blob";
  public static final String GLOBAL_PROFILE_BLOB_TABLE  =  "SEEV_GLOBAL_PROFILE_BLOB";
  public static final String EVALUATION_TABLE       = "SEEV_EVALUATION";
  public static final String USED_PROFILE_TABLE     = "seev_used_profile";
  public static final String FEEDBACK_SESSION_TABLE = "SEEV_FEEDBACK_SESSION";
  public static final String IDSTR_PREFIX = "id";  
  public static final String DEFAULT_TITLE = "NO TITLE";
  public static final String BASE_ADDRESS = "index.jsp";
  public static String LOG_PATH = "c:\\log.txt";
  public static final String ACCOUNT_PATH = "account.dat";
  public static final String STOPWORDS_PATH = "stopwords.txt";
  
  public static final String HOST = "139.19.50.39";
  public static final String SERVICE = "bingo.world";
  public static final String LOGIN = "search1";
  public static final String PASSWORD = "Q";
  
  public static Log_Semafor log_semafor;

  public static final int TOPK = 200;  
  public static final int DEFAULT_USER_ID = -1;  
  public static final int BAD_ID = -2;
  public static final int MAXRproP = 50;
  public static final int COOKIELIFETIME = 2600000; //1 month
  public static final String COOKIENAME = "seev_cookie";
  
  public static final String   DEFAULT_OBJECT = " ";
  public static final Double   DEFAULT_VALUE  = new Double(1.0);
  public static final String   DEFAULT_KEY    = new String("null");
  public static final Stemmer  stemmer        = new Stemmer();

  public static final int       DEFAULT_THREADS_NUM = 10;
  
  public static Session_Killer S_K;
  
  public static GlobalProfile[] GLOBALPROFILES;
  
  public Constants() 
  {
    if (LOG_PATH == null) 
     LOG_PATH = System.getProperty( "user.dir" )+ System.getProperty( "file.separator" )+"log.txt";  
    synchronized(this.getClass())
    {
     if (log_semafor == null) 
      log_semafor = new Log_Semafor();
    }
  }
  

  public static void get_killer()
  {
   if (S_K==null || !S_K.getStatus()) 
    {
     S_K = new Session_Killer();
     new Thread(S_K).start();
    }
  }
  
  public void get_global_profiles()
  {
    if (GLOBALPROFILES == null)
     {
       Global_Profiles_Constructor GPC = new Global_Profiles_Constructor();
       GPC.process();
     }
  }
    
  public String getIDStr(long _ID)
  {
    return IDSTR_PREFIX+_ID;  
  }
  
  public long getNewID()
  {
    return new Date().getTime();   
  }
    
  public String vector_to_string(double[] x, int digit)
  {
    if (x == null) return null;
    if (digit <= 0 || digit > 12) digit = 4;
    double d = Math.pow(10.0, (double)digit);
    String S = "";
    for (int i=0; i<x.length; i++)
      S += " " + Math.round(x[i]*d)/d;    
    return S;
  }
}
