package search;

import java.lang.*;
import java.util.*;
import java.io.*;

public class GlobalProfile extends Profile implements Serializable
{
  public ProfileCluster cluster;
  private FeedbackCluster feedbackCluster;
  
  public GlobalProfile(long _profileID, double[] _w, ProfileCluster _cluster)
  {
    if (_w != null && _w.length == GLOBAL_NF && _profileID != 0 && _cluster!= null && !_cluster.get_error_status()) 
     {
      w = _w;
      profileID = _profileID;
      LongProfileID = new Long(profileID);
      cluster = _cluster;
      this.unset_error_status();
     }
     else set_error_status();      
  }
  
  public GlobalProfile(double[] _w, ProfileCluster _cluster) 
  {
    if (_w != null && _w.length == GLOBAL_NF && _cluster!= null && !_cluster.get_error_status()) 
     {
      w = _w;
      profileID = getNewID();
      LongProfileID = new Long(profileID);
      cluster = _cluster;
      this.unset_error_status();
     }
     else set_error_status();
  }    
  
  public void setFeedbackCluster(FeedbackCluster _feedbackCluster)
  {
    if (_feedbackCluster == null || _feedbackCluster.get_error_status() || _feedbackCluster.getProfileID_longvalue() != this.profileID) set_error_status();
    feedbackCluster = _feedbackCluster;
  }
  
  public FeedbackCluster getFeedbackCluster()
  {
    if (get_error_status()) return null;
    return feedbackCluster;
  }
   
}
