package search;

import java.lang.*;
import java.util.*;
import javax.servlet.http.*;


public class Manager extends Error
{ 
 private DBconnect DB;
 private Query_Parser parser;
 private Query query;
 private String TF = new String();
 
//jsp page output parameters
 private boolean    TmFt        = false;
 private boolean    prefix      = false;
 private long       searchIn    = 0;
 private String     queryStr    = new String();
 private boolean    TFchecked   = false; 
 private long       ID          = 0;
 private long       _ID         = 0;
 private int        RPage       = 0;
 private int        _RPage      = 0;
 private int        RproP       = RESULTS_PRO_PAGE;
 private long       IDD         = 0;
 private boolean    SIM         = false;
 private boolean    Neighbor    = false;
 private String     inClass     = null;
 private boolean    feedbackValid = false;
 private int[]      feedback    = new int[MAXRproP];
 private long[]     feedback_doc = new long[MAXRproP];
 private boolean    feedback_session = false;
 private long       usedprofileID = 0;
 private User       user = null;
 private boolean    evaluation_session = false;

 private Session session;
 private String compositQuery = new String();
 private String UserHost = "";
 
 
 public Scroll scroll   =  null; 
 public Result result   =  null;
 public boolean submit = false;

 private Result_List result_list = null;
 private Feedback feedback_view = null;
 private Profile profile = null;
 private Profile_Recognizer profile_recognizer = null;
 
 
 public Manager() 
 {      
  DB = new DBconnect();
  parser = new Query_Parser();
  profile_recognizer = new Profile_Recognizer();
 }
 
 public void Reset()
 {
   this.unset_error_status();  
   compositQuery=BASE_ADDRESS;  
   queryStr="";
   RproP       = RESULTS_PRO_PAGE;
   TF="";
   TmFt = false;
   prefix=false;
   TFchecked=false;
   feedbackValid = false;
   RPage=0;
   ID=0;
   UserHost="";
   SIM = false;
   Neighbor = false;
   IDD = 0;
   for (int i=0; i<MAXRproP; i++)
    feedback[i] = NEUTRAL;
   result = null;
   scroll = null;
   DB.CloseConnect();
   inClass = null;
   feedback_session = false;
   feedback_view = null;
   get_killer();
   profile = null;
   usedprofileID = 0;
   user = null;
   submit = false;
   evaluation_session = false;
   result_list = null;
   session = null;
   System.gc();
 }

 public void execute()
 {  
  if (submit)
  {RPage=0; ID=0;}   
  try
  {
   if (!DB.OpenConnect()) 
    {
     set_error_status();
     set_error_message("the database can not be opened");
    }
   if (evaluation_session) //EVALUATION
   {
     RPage = _RPage;
     ID = _ID;
     session = new Session(DB, ID);
     if (session!=null && !session.get_error_status())
      {
       result_list = session.get_unit_list();

       Query query = session.getQuery();
       if (query != null && query.get_error_status())  queryStr = query.getqueryStr();
       
       if (result_list != null && !result_list.get_error_status())
       {
        int n = 0;
        for (int i=0; i<RproP; i++) if (feedback[i]== this.POSITIV || feedback[i] == this.NEGATIV) n++;

        if (n>0)
         {
           Feedback_Document[] F_D_L = new Feedback_Document[n]; 
           int j=0;
           for (int i=0; i<RproP; i++)
            if (feedback[i]== this.POSITIV || feedback[i] == this.NEGATIV)
            {
             Feedback_Document F_D = new Feedback_Document(feedback_doc[i], feedback[i]);
             F_D_L[j] = F_D;
             j++;
            }
           
           feedback_view = new Feedback(F_D_L);
           DB.storeFeedback(session.getsessionID(), feedback_view);
           DB.storeEvaluation(feedback_view.getID());
           result_list = session.get_unit_list();
           profile = DB.get_used_profile(session.getsessionID());
           if (profile != null)
           {
             result_list.set_profile(profile.getWeightVector());  
           }
           feedbackValid = true;
         }
       }       
      }
     else
      {
        set_error_status();
        set_error_message("Feedback is broken");
      }       
   }
   else 
   if (feedback_session)  //FEEDBACK
   {
     RPage = _RPage;
     ID = _ID;
     session = new Session(DB, ID);
     if (session!=null && !session.get_error_status())
      {
       result_list = session.get_unit_list();

       Query query = session.getQuery();
       if (query != null && query.get_error_status())  queryStr = query.getqueryStr();
       
       if (result_list != null && !result_list.get_error_status())
       {
        int n = 0;
        for (int i=0; i<RproP; i++) if (feedback[i]== this.POSITIV || feedback[i] == this.NEGATIV) n++;

        if (n>0)
         {
           Feedback_Document[] F_D_L = new Feedback_Document[n]; 
           int j=0;
           for (int i=0; i<RproP; i++)
            if (feedback[i]== this.POSITIV || feedback[i] == this.NEGATIV)
            {
             Feedback_Document F_D = new Feedback_Document(feedback_doc[i], feedback[i]);
             F_D_L[j] = F_D;
             j++;
            }
           
           feedback_view = new Feedback(F_D_L);
           DB.storeFeedback(session.getsessionID(), feedback_view);
           profile = profile_recognizer.getDistinctProfile(result_list, feedback_view);
           
           result_list = session.get_unit_list();           
           
           if (profile != null)
            {
             DB.storeDistinctProfile(feedback_view.getID(), profile);           
             usedprofileID = profile.getID();           
             DB.store_used_profile(usedprofileID, session.getsessionID());
             result_list.set_profile(profile.getWeightVector());
            }
           feedbackValid = true;
         }
       }       
      }
     else
      {
        set_error_status();
        set_error_message("Feedback is broken");
      }
   }
   else 
   if (queryStr!=null && queryStr.length()>1) //NEW QUERY
   {        
    if (ID==0) //NEW QUERY
      {
        //PARSE QUERY 
        parser.setTmFt(TmFt);
        query = parser.parse(queryStr);

        if (inClass !=null && inClass!="" && !inClass.equals(DEFAULT_CLASS))
        {            
         Term_Parser TP = new Term_Parser(inClass, TmFt);
         TP.setTYPE(CLASS);
         query.put(TP.getTYPE(), TP.getTERM(), DEFAULT_VALUE);
        }

        query.fill_empty_dimesions();
        for (int i=0; i<GLOBAL_NF; i++)
          if (query.getDimSize(i) == 0 && this.ISKEY[i]) {this.set_error_status();}
              
        //CREATE a new SESSION
        if (!this.get_error_status())
        {
         if (user!= null && !user.get_error_status())
          session = new Session(DB, user.getID_long_value(), UserHost, query);
         else
         session = new Session(DB, UserHost, query);         
        }
        
        //result_list = session.get_unit_list();                      
        //profile = profile_recognizer.getGlobalProfile(result_list);                 
      }
      else //IF ID EXIST (<> 0)      
       { 
         session = new Session(DB, ID); 
       } 
    feedbackValid = true;
   }  
   else
   if (ID!=0) //SCROLLING
   {
     session = new Session(DB, ID);
     feedbackValid = true;
     
     Query query = session.getQuery();
     if (query != null && !query.get_error_status())  queryStr = query.getqueryStr();
   }
   
  // FOR NONFEEDBACK SESSION WE SET UP A PROFILE IF IT EXISTS
  if (!feedback_session && session!=null && !session.get_error_status())
   {
    result_list = session.get_unit_list(); 
    if (ID!=0) profile = DB.get_used_profile(session.getsessionID());
    if (profile != null)
     {
       usedprofileID = profile.getID();
       result_list.set_profile(profile.getWeightVector());
     }
   }   
 
  if (result_list!=null && !result_list.get_error_status()) 
   {
    prepareUserView(result_list);
   }
  }
  catch (Exception e)
  {
    this.set_error_message("fuck: \n"+e.toString());  
  }
  
  DB.CloseConnect();
 }
 
 /// end of execute
 
 public String getWelcome()
 {
   String wel = "";
   if (user!=null) wel += "You are "+user.getName() +", aren't you!";
   else wel += "You can login or register here >><br>";
   return wel;
 }
 
 public boolean isLogin()
 {
  if (user== null || user.get_error_status()) return false;
  return true;
 }
 
 public void setCookies(Cookie[] cookies)
 {
   if (cookies!=null)
   {
     int k=0;  
     String userid = new String();
     while (k<cookies.length && !cookies[k].getName().equals(COOKIENAME)) 
      {
       String str = cookies[k].getName();
       k++;
      }
     
     if (k < cookies.length) userid = cookies[k].getValue();
     regDB reg = new regDB();
     user = reg.getUser(userid);
     //set_error_message(" "+userid+" "+user.get_error_status()+" "+user.toString());
     reg.CloseConnect();
   }
 }
 
 private boolean prepareUserView(Result_List r_l)
 {
   if (r_l == null || r_l.get_error_status()) return false;  
   scroll = new Scroll();
   int N = r_l.getPositiveLength();
   compositQuery = createCompositQuery(compositQuery, session.getsessionID());
   scroll.create(RPage, RproP, N, session.getsessionID(), compositQuery);
   if ((RPage+1)* RproP > N) N = N - RPage*RproP;
    else
     if (N>RproP) N = RproP; 
   result = new Result(DB.ObtainDocBodies(r_l, session.getsessionID(), RPage*RproP, N));
   result.setStartNum(RPage*RproP);
   return true;
 }
  
 
 //***********************************INPUT OUTPUT
 
 
 //get data from html form of jsp page

 public String print_profile()
 {
   if (profile != null && !profile.get_error_status()) return "<p>Current profile: " +profile.toString()+"</p>";
   return "";
 }
 
 public boolean FeedbackValid()
 {
   return feedbackValid;  
 }
 
 public void setqueryStr(String x)
 {   
  if (x==null || x=="") set_error(EMPTY_QUERY);
  else 
  {  
   queryStr=x;
   submit = true;
  }  
 }
 
 public void setsubmit_query(String x)
 {
  if (x!=null) submit = true;
 }
 
 
 public void setsubmit_Feedback(String x)
 {
  if (x!=null) feedback_session = true;
 }

 public void setsubmit_Evaluation(String x)
 {
  if (x!=null) evaluation_session = true;  
  set_error_message("au");
 } 
 
 public void setsearchIn(String x)
 {
   if (x!="") 
   {
    Long I = new Long(x);
    if (I!=null) searchIn=I.longValue();
     else {set_error_message("manager: BAD ID FORMAT"); searchIn=0;} 
   }
 }
 
 public void setinClass(String x)
 {
   inClass=x;
 }
 
 public void setID(String x)
 {
   if (x!="") 
   {
    Long I = new Long(x);
    if (I!=null) ID=I.longValue();
     else {set_error_message("manager: BAD ID FORMAT"); ID=0;} 
   }
 }
 
 public void setNEXTPAGE(String x)
 {
   if (x!="") 
    {
      Integer I = new Integer(x);
      if (I!=null) RPage = I.intValue();   
    }
 }

 
 public void setIDF(String x)
 {
   if (x!="") 
   {
    Long I = new Long(x);
    if (I!=null) _ID=I.longValue();
     else {set_error_message("manager: BAD ID FORMAT"); _ID=0;} 
   }
 }
 
 
 public void setIDD(String x)
 {
   if (x!="") 
   {
    Long I = new Long(x);
    if (I!=null) IDD=I.longValue();
     else {set_error_message("manager: BAD ID FORMAT"); IDD=0;} 
    set_error_message("Executor IDD: "+x+" "+IDD);
   }
 }
 
 public void setfeedback_submit(String x)
 {
   if (x!=null && x.equals("Submit")) submit = true;  
 }
 
 

 public void setpageF(String x)
 {
   if (x!="") 
    {
      Integer I = new Integer(x);
      if (I!=null) _RPage = I.intValue();   
    }
 }
 
 
 public void setrequest(String Query, String RemoteHost)
 {
  if (Query != null) 
  compositQuery = BASE_ADDRESS+"?"+Query;
  int n = compositQuery.indexOf("&id");
  if (n>0) compositQuery = compositQuery.substring(0,n);
  UserHost = RemoteHost;
  set_error_message("Request :"+Query+" "+RemoteHost);
 }

 public void setSIM(String x)
 {
  if (x.equals("SIM")) SIM = true;
  else SIM = false;   
 }
  
 public void setNEIGHBOR(String x)
 {
   if (x.equals("YES")) Neighbor = true;
    else Neighbor = false;
 }
 
 public void setdocFeedback(String x, int i)
 {
   if (i>=0 && i < this.MAXRproP)
    {   
    if (x == null || x == "") 
     {feedback[i] = NEUTRAL; feedback_doc[i] = 0;} 
    if (x.toString().startsWith(this.NEGATIV_FEEDBACK)) 
     {
      feedback[i] = NEGATIV; 
      String S = x.toString().substring(this.NEGATIV_FEEDBACK.length());
      feedback_doc[i]= new Long(S).longValue();
     }
    if (x.toString().startsWith(this.POSITIV_FEEDBACK))
     {
      feedback[i] = POSITIV; 
      String S = x.toString().substring(this.POSITIV_FEEDBACK.length());
      feedback_doc[i]= new Long(S).longValue();
     }
   }
 }
 
 public void setdocFeedback0(String x)
 {
   setdocFeedback(x, 0);  
 }

 //get data from html form of jsp page
 
 
 public String getTF(int type)
 {
  if (!TFchecked) 
   {
     if ((TmFt && type == 1)||(!TmFt && type ==0 )) 
     {     
      TFchecked=true;  
      return "checked";  
     }
     else return "";
   }
  return "";
 }
 
 //class iterator inteface
 private Iterator It = null;
 
 public boolean hasnextClass()
 {
   if (It==null)
   {
     DBconnect DBp = new DBconnect();  
     Collection C = DBp.getClasses();
     if (C==null) {set_error_status(); set_error_message("There are no classes"); return false;}
     It = C.iterator();
     DBp.CloseConnect();
   }
   if (It.hasNext()) return true;
    else It=null;
   return false;
 }
 
 public String nextClass()
 {
  boolean b = true;   
  if (It==null) b = hasnextClass();
  if (b) return It.next().toString();
   else It=null; 
  return null;
 }
 
 public String getSelectedClass(String ClassName)
 {
  if (inClass!=null && inClass.equals(ClassName)) return "selected";
  return "";
 }
 //class iterator inteface
 
 //additional interface functions
 
 public String createCompositQuery(String Q, long _ID)
 { 
   if (Q==null) return null;
   String temp = Q;
   temp = extractSubString(temp, "?ID=", "&");    
   temp = extractSubString(temp, "&USEDPROF", "&");
   temp = extractSubString(temp, "&NEXTPAGE", "&");   
   if (temp.endsWith(BASE_ADDRESS)) temp+="?ID="+_ID;
    //else temp+="&ID="+_ID;
   return temp;
 }
 
 private String extractSubString(String main, String Pre, String Suf)
 {
   if (main==null || Pre==null || Suf==null) return null;
   int b = main.indexOf(Pre);
   int e = main.indexOf(Suf,b);
   String temp = main;
   if (b!=-1)
   {
     temp = main.substring(0,b);
      if (e>b)
       temp+=main.substring(e);
    }
   return temp;  
 }
 
 public String getqueryStr()  
 {
     
   return queryStr;  
 }
  
 public String getID()
 {
   if (session!=null && !session.get_error_status())
    return ""+session.getsessionID();
   return null;    
 }
 
 public boolean searchIn()
 {
   return true;   
 }
 
 public int getRPage()
 {
   return RPage;  
 }

 //FEDBACK RECOGNITION, a little bit stupid but ...
 public void setdocFeedback1(String x)
 {
   setdocFeedback(x, 1);  
 }

 public void setdocFeedback2(String x)
 {
   setdocFeedback(x, 2);  
 }
 
 public void setdocFeedback3(String x)
 {
   setdocFeedback(x, 3);  
 }
 
 public void setdocFeedback4(String x)
 {
   setdocFeedback(x, 4);  
 }
 
 public void setdocFeedback5(String x)
 {
   setdocFeedback(x, 5);  
 }
 
 public void setdocFeedback6(String x)
 {
   setdocFeedback(x, 6);  
 }
 
 public void setdocFeedback7(String x)
 {
   setdocFeedback(x, 7);  
 }
 
 public void setdocFeedback8(String x)
 {
   setdocFeedback(x, 8);  
 }
 
 public void setdocFeedback9(String x)
 {
   setdocFeedback(x, 9);  
 }
 
 public void setdocFeedback10(String x)
 {
   setdocFeedback(x, 10);  
 }
 
  public void setdocFeedback11(String x)
 {
   setdocFeedback(x, 11);  
 }
  
 public void setdocFeedback12(String x)
 {
   setdocFeedback(x, 12);  
 }
 
 public void setdocFeedback13(String x)
 {
   setdocFeedback(x, 13);  
 }
 
 public void setdocFeedback14(String x)
 {
   setdocFeedback(x, 14);  
 }
 
 public void setdocFeedback15(String x)
 {
   setdocFeedback(x, 15);  
 }
 
 public void setdocFeedback16(String x)
 {
   setdocFeedback(x, 16);  
 }
 
 public void setdocFeedback17(String x)
 {
   setdocFeedback(x, 17);  
 }
 
 public void setdocFeedback18(String x)
 {
   setdocFeedback(x, 18);  
 }
 
 public void setdocFeedback19(String x)
 {
   setdocFeedback(x, 19);  
 }
 
 public void setdocFeedback20(String x)
 {
   setdocFeedback(x, 20);  
 }
 
 public void setdocFeedback21(String x)
 {
   setdocFeedback(x, 21);  
 }

 public void setdocFeedback22(String x)
 {
   setdocFeedback(x, 22);  
 }
 
 public void setdocFeedback23(String x)
 {
   setdocFeedback(x, 23);  
 }
 
 public void setdocFeedback24(String x)
 {
   setdocFeedback(x, 24);  
 }
 
 public void setdocFeedback25(String x)
 {
   setdocFeedback(x, 25);  
 }
 
 public void setdocFeedback26(String x)
 {
   setdocFeedback(x, 26);  
 }
 
 public void setdocFeedback27(String x)
 {
   setdocFeedback(x, 27);  
 }
 
 public void setdocFeedback28(String x)
 {
   setdocFeedback(x, 28);  
 }
 
 public void setdocFeedback29(String x)
 {
   setdocFeedback(x, 29);  
 }
 
 public void setdocFeedback30(String x)
 {
   setdocFeedback(x, 30);  
 }
 
 public void setdocFeedback31(String x)
 {
   setdocFeedback(x, 31);  
 }
 
 public void setdocFeedback32(String x)
 {
   setdocFeedback(x, 32);  
 }
 
 public void setdocFeedback33(String x)
 {
   setdocFeedback(x, 33);  
 }
 
 public void setdocFeedback34(String x)
 {
   setdocFeedback(x, 34);  
 }
 
 public void setdocFeedback35(String x)
 {
   setdocFeedback(x, 35);  
 }
 
 public void setdocFeedback36(String x)
 {
   setdocFeedback(x, 36);  
 }
 
 public void setdocFeedback37(String x)
 {
   setdocFeedback(x, 37);  
 }
 
 public void setdocFeedback38(String x)
 {
   setdocFeedback(x, 38);  
 }

 public void setdocFeedback39(String x)
 {
   setdocFeedback(x, 39);  
 }
 
 public void setdocFeedback40(String x)
 {
   setdocFeedback(x, 40);  
 }
 
 public void setdocFeedback41(String x)
 {
   setdocFeedback(x, 41);  
 }
 
 public void setdocFeedback42(String x)
 {
   setdocFeedback(x, 42);  
 }
 
 public void setdocFeedback43(String x)
 {
   setdocFeedback(x, 43);  
 }
 
 public void setdocFeedback44(String x)
 {
   setdocFeedback(x, 44);  
 }
 
 public void setdocFeedback45(String x)
 {
   setdocFeedback(x, 45);  
 }
 
 public void setdocFeedback46(String x)
 {
   setdocFeedback(x, 46);  
 }
 
 public void setdocFeedback47(String x)
 {
   setdocFeedback(x, 47);  
 }
 
 public void setdocFeedback48(String x)
 {
   setdocFeedback(x, 48);  
 }
 
 public void setdocFeedback49(String x)
 {
   setdocFeedback(x, 49);  
 } 
}