package search;

import java.lang.*;
import java.util.*;

public class Profile extends Error
{

  protected double[] w;
  protected long profileID = 0;
  protected Long LongProfileID = new Long(0);
  
  public Profile()
  {
    set_error_status(); 
    profileID = getNewID();
    LongProfileID = new Long(profileID);    
  }
  
  public Profile(long _profileID, double[] _w)
  {
    if (_w != null && _w.length == GLOBAL_NF && _profileID != 0) 
     {
      w = _w;
      profileID = _profileID;
      LongProfileID = new Long(profileID);
     }
     else set_error_status();      
  }
  
  public Profile(double[] _w) 
  {
    if (_w != null && _w.length == GLOBAL_NF) 
     {
      w = _w;
      profileID = getNewID();
      LongProfileID = new Long(profileID);
     }
     else set_error_status();
  }
  
  public boolean setWeights(double[] _w)
  {
    if (_w == null && _w.length != GLOBAL_NF) return false;
    w = _w; 
    this.unset_error_status();
    return true;  
  }
  
  public double getWeight(int i)
  {
    if (!get_error_status() && i>=0 && i<GLOBAL_NF) return w[i];   
    return 0;
  }
  
   
  public long getID()
  {
    return profileID;  
  }
  
  public Long get_Long_ID()
  {
    if (get_error_status()) return null;
    return LongProfileID;
  }
  
  public double[] getWeightVector()
  {
    if (!get_error_status()) return w;
    return null;
  }
  
  public String toString()
  {
   if (get_error_status()) return null;
   String S = new String();
   S = " length "+w.length+" >> ";
   for (int i=0; i<w.length; i++)
    S = S + " | " + Math.floor(w[i]*10000)/10000;
   S += " | ";
   return S;
  }
    
}
