package search;

import java.lang.*;
import java.util.*;


public class Profile_Recognizer extends Error
{
    
    public Profile_Recognizer() 
    {
    }
    
    public Profile getDistinctProfile(Result_List r_l, Feedback feedback)
    {
      if (r_l!=null && !r_l.get_error_status() && feedback!=null && !feedback.get_error_status())
       {
         //Linear_Regression L_R = new Linear_Regression(r_l, feedback);
         //double[] p_vector = L_R.computeProfile();
         
         deltaXY dXY = new deltaXY(r_l, feedback);
         double[] p_vector = dXY.computeProfile();
         
         //Natural_Score_Approach NSA = new Natural_Score_Approach(r_l, feedback);
         //double[] p_vector = NSA.computeProfile();
         
         p_vector = normalize(p_vector, 1.0);
         if (p_vector == null) return null;
         
         Profile profile = new Profile(p_vector);
         
         set_error_message("Profile: "+profile.toString());

         if (!profile.get_error_status()) return profile;         
       }
      return null;
    }
    
    public Profile getUnitProfile()
    {
      double[] p = new double[GLOBAL_NF];
      Arrays.fill(p, 1.0);
      Profile P = new Profile(p);
      return P;
    }
    
    public Profile getGlobalProfile(Result_List RL)
    {
      if (get_error_status() || RL == null || RL.get_error_status()) return null;
      this.get_global_profiles();
      if (this.GLOBALPROFILES == null) return null;
      int n = this.GLOBALPROFILES.length;
      double[] scores = new double[n];
      for (int i=0; i<n; i++)
       {
         FeedbackCluster FC = GLOBALPROFILES[i].getFeedbackCluster();
         if (FC != null) scores[i] = FC.estimateResultList(RL);
       } 
      
      int j = 0;
      for (int i=0; i<n; i++)
        if (scores[i]>0 && scores[i] > scores[j]) j=i;
      Profile p = null;
      if (scores[j]>0) p = (Profile)GLOBALPROFILES[j];
      if (p == null) return this.getUnitProfile();
      return p;
    }
    
    public Profile get_general_profile()
    {
      return null;   
    }
    
    public double[] normalize(double[] _p_vector, double n)
    {
      if (_p_vector == null || get_error_status() || n == 0) return null;
      double [] p_vector = new double[_p_vector.length];
      double max = 0.0;      
      for (int i=0; i<_p_vector.length; i++)
        if (max < Math.abs(_p_vector[i])) max = Math.abs(_p_vector[i]);
      max = max/n;  
      if (max == 0) return null;
       for (int i=0; i<_p_vector.length; i++)
         p_vector[i] = _p_vector[i]/max; 
      return p_vector;
    }
    
}
