package search;

import java.io.*;
import java.lang.*;

public class Register extends Error
{
 private regDB DB;

 private String name;
 private String login;
 private String pass;
 private String email;
 private String rpass;
 private final static String[] ERROR_MESSAGES = {"please choose another login", "the password is wrong or empty", "please verify your email, it is empty or wrong", "please enter your name", "please enter the login", "please verify your passwords, they are empty or not equal", "the user with this email has already been registered"};
 private int error_status = -1;
 private boolean justcamein = true;
 
   public Register() 
   {
     DB = new regDB();  
   }
   
   public void reset()
   {
    name  = null;
    login = null;
    pass  = null;
    email = null;
    rpass = null;
    error_status = -1;
    justcamein = true;
   }
    
   public void process()
   {
    DB.OpenConnect();  
    if (name == null) error_status = 3;
     else if (login == null) error_status = 4;
      else if (email == null) error_status = 2;
       else if (pass == null || rpass == null || !pass.equals(rpass)) error_status = 5;
        else if (DB.isLogin(login)) error_status = 0;
         //else if (DB.isEmail(email)) error_status = 6;
     if (error_status == -1)
      {
        User user = new User(login, email, pass, name);  
        DB.createUser(user);
        error_status = -2;
      }
    DB.CloseConnect();
   }
   
   public boolean isError()
   {
     if (error_status >= 0) return true;
     return false;
   }
   
   public boolean isSuccess()
   {
     if (error_status < -1) return true;
     return false;
   }
   
   public String getError()
   {
     if (justcamein) return "please fill all the fields and press the button \"register\" to register";
     if (error_status >= 0 && error_status < ERROR_MESSAGES.length) return ERROR_MESSAGES[error_status];
     else if (error_status == -2) return "You have been registered!";
     else return "";
   }
   
   public void setname(String x)
   {
     name = x;  
   }   
   
   public void setregister(String x)
   {
     if (x != null) justcamein = false;  
   }   
   
   public String getname()
   {
     if (name != null) return name;
     return "";
   }

   public void setlogin(String x)
   {
     login = x.toLowerCase();  
   }
   
   public String getlogin()
   {
     if (login != null) return login;  
     return "";
   }

   public void setpass1(String x)
   {
     pass = x;  
   }
   
   public void setpass2(String x)
   {
     rpass = x;  
   }

   public void setemail(String x)
   {
     email = x;  
   }   
   
   public String getemail()
   {
     if (email!=null) return email;  
     return "";
   }
   
}
