package search;

import java.lang.*;
import java.util.*;

public class Result_Body extends Error 
{
 private String title=null;
 private String URL=null;
 private String Description=null; 
 private String ClassName = null;
 private long LastDate=0;
 private double size; 
 private long ID=0;
 private long GID=0;
 private boolean status = true;
 private double[] scores;
 private int feedback_status = this.NEUTRAL;
 
 public Result_Body(String _url, String _title, String _Desc, double _size, String _Class, long _ID, long _LastDate, long _GID) 
  {
    status = true;  
    
    if (_url!="") {URL=_url;}
     else 
     {
      set_error_message("result: no URL");
      status = false;
     }
    
    if (_title!="") {title=_title;}
     else 
     {
      set_error_message("result: no Title");   
     } 
    
    if (_ID!=0) ID=_ID;
     else
     {
      set_error_message("result: no ID");   
      status=false;   
     }

    if (_GID!=0) GID=_GID;
     else
     {
      set_error_message("result: no GID");   
      status=false;   
     }
    
    if (_Desc!="")
     {
       Description = _Desc;  
     }
     else   
     {
      set_error_message("result: no Desription");   
     } 
     
    if (_size>0) size=_size;
      else size=0.1;
    
    if (_Class!="")
     {
       ClassName = _Class;  
     }
     else   
     {
      set_error_message("result: no Class");   
     } 
    
    if (_LastDate>0) LastDate=_LastDate;
     else LastDate= new Date().getTime();
  }

 public void setScores(double[] w)
 {
   if (w!=null) scores = w;
 }
 
 public boolean getStatus()
 {
  return status;   
 }
 
 public void set_feedback_status(int _status)
 {
   if (_status == this.POSITIV || _status == this.NEGATIV) feedback_status = _status;  
 }
 
 public int get_feedback_status()
 {
   return feedback_status;  
 }
 
 public String getTitle()
 {
   String s = "";  
   
   /*
   if (scores != null)
    for (int i=0; i<scores.length; i++) s = s + " "+Math.round(scores[i]*1000.0)/1000.0; 
   s = " > " + " " + getDOCID() + " " + s + " < ";
   */
   
   s=title+s;
   return s;  
 }
 
 public String getTextURL()
 {
   String temp = URL;
   //if (URL.length()>constants.URL_RES_LEN) temp = URL.substring(0,constants.URL_RES_LEN);
   int k = 1;
   while (temp.length() > k*URL_RES_LEN+4*(k-1))
    {
      temp = temp.substring(0, k*URL_RES_LEN+4*(k-1)-1) + "<br>" + temp.substring(k*URL_RES_LEN+4*(k-1), temp.length());
      k++;      
    }
   return temp;  
 }
 
 public String getURL()
 {
   return URL;  
 }
 
 public String getDesc()
 {
  return Description;   
 }
 
 public String getClassName()
 {
   return ClassName;  
 }
 
 public double getSize()
 {
   return size;  
 }
 
 public String getDate()
 {
   Date D = new Date(LastDate);
   String T[] = D.toString().split(" ");
   return T[2]+" "+T[1]+" "+T[5];
 }
 
 public String getDOCID()
 {
   String S = ""+ID;
   return S;
 }
 
 public String getFeedbackEntry(int f_status)
 {
   if (f_status == this.NEGATIV) return this.NEGATIV_FEEDBACK+getDOCID();
   if (f_status == this.POSITIV) return this.POSITIV_FEEDBACK+getDOCID();
   return "";
 }
}
