package search;

import java.util.*;
import java.lang.*;


public class Result_Document extends Error implements Comparable 
{
//DATA BLOCK
    private Long doc_id = new Long(0);
    public double[] scores;
    public double[] unit_scores;
    public double sum = 0;
    
    private int NF = GLOBAL_NF;


//FUNCTION BLOCK
    public Result_Document(long _doc_id, double[] D) 
    {
     if (D!=null || _doc_id != 0) 
      { 
       doc_id = new Long(_doc_id);
       unit_scores = (double[])D.clone();
       scores = (double[])D.clone();
       this.compute_sum();
      }
     else
      {
        set_error_status();
      }
    }
    
    public Long get_doc_id()
    {
      return doc_id;  
    }
    
    public long get_doc_id_longValue()
    {
      return doc_id.longValue();  
    }
    
    public void normalize_by_average(double[] average)
    {
      if (average == null || average.length != GLOBAL_NF) return;
      for (int i=0; i<NF; i++)
       if (average[i] > 0)  scores[i] = scores[i]/average[i];
      this.compute_sum();
    }
    
    public boolean set_profile(double[] profile)
    {
      if (profile == null || profile.length != NF) return false;
      for (int i=0; i<NF; i++)
       scores[i] = unit_scores[i]*profile[i];
      this.compute_sum();
      return true;
    }
    
    public void compute_sum()
    {
      sum = 0.0;  
      for (int i=0; i<NF; i++) sum += scores[i];
      sum = sum/(double)NF;        
    }
    
    public double Sum()
    {  
      if (sum == 0) this.compute_sum();  
      return sum;
    }
    
    public void setNF(int _NF)
    {
      if (_NF > 0) NF = _NF;  
    }
    
    public int getNF()
    {
      return NF;  
    }
    
    //inverted comparator
    public int compareTo(Object O)
    {
      if (O==null) return 0;
      Result_Document RD = (Result_Document)O;
      if (RD==null) return 0;
      
      if (RD.Sum()<Sum()) return -1;
       else if (RD.Sum()>Sum()) return 1;
         return 0;
    }
    
    
}
