package search;

import java.util.*;
import java.lang.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import net.sf.snowball.*;
import java.util.regex.*;

import java.lang.reflect.Method;

public class Stemmer extends Error
{
  private SnowballProgram stemmer;
  private Method stemMethod;
  private Object[] emptyArgs;
  private int repeat = 1;
  public static Class stemClass = null; 
  private static HashSet stopWords;
  public static URL  sStopwordFile;  
  

  public Stemmer()
  {
    try
    {
      setStemmerLanguage("english");
      stemmer = (SnowballProgram)stemClass.newInstance() ;
      stemMethod = stemClass.getMethod( "stem", new Class[0] );;
      emptyArgs = new Object[0];
    }
    catch ( Exception e )
    {
      e.printStackTrace();
    }
  }
  
  public static Pattern[] patterns =
  {
    Pattern.compile(""),
    Pattern.compile(""),
    Pattern.compile(""),
    Pattern.compile("")
  };
  
  public void setStemmerLanguage( String language )
  {
     try
     {
        stemClass = this.getClass().getClassLoader().loadClass( "net/sf/snowball/ext/" + language + "Stemmer" );
        setStopwords();
     }
     catch ( Exception e )
     {
        e.printStackTrace();
     }
   }

  
   private void setStopwords()
   {
      try
      {
         sStopwordFile = this.getClass().getClassLoader().getResource(STOPWORDS_PATH);          
         BufferedReader buf = new BufferedReader( new InputStreamReader( sStopwordFile.openStream() ) );
         String tmp;
         StringTokenizer st = null;
         
         stopWords = new HashSet();
         
         while ( ( tmp = buf.readLine() ) != null )
         {
            tmp.replaceAll( "\\W", " " );
            st = new StringTokenizer( tmp );
            
            while ( st.hasMoreTokens() )
            {
               String token = st.nextToken().toLowerCase().trim();
               if ( token != null && token.length() > 0 )
               {
                  stopWords.add( token );
               }
            }
         }
         buf.close(); buf=null;         
       }
      catch ( Exception e )
      {
         e.printStackTrace();
      }
   }

  
  
  public static String[] replacements =
  {
    "ae",
    "ue",
    "oe",
    "ss"
  };
  

   public boolean isStopword( String s )
   {
      return ( stopWords.contains( s ) );
   }  
  
  public String stem(String s)
  {
    ArrayList AL = stem(s.toCharArray());
    if (AL == null || AL.size() == 0) return null;
    TextItem TI = (TextItem)AL.get(0);
    return TI.stem;
  }
  
  
  public ArrayList stem( char[] data )
  {
    return stem(data, data.length);
  }
  
  public ArrayList stem (char[] array, int pos)
  {
    ArrayList tokens = new ArrayList(200);
    int a=0, b=0;
    while (a < pos)
    {  
       if  ((array[a] >= 65 && array[a] <= 90 ) ||
              (array[a] >= 97 && array[a] <= 122 ) ||
              (array[a] == 196) ||
              (array[a] == 214) ||
              (array[a] == 220) ||
              (array[a] == 228) ||
              (array[a] == 246) ||
              (array[a] == 252) ||
              (array[a] == 223))
        {
        b = a + 1; 
        while (b < pos &&
              (
              (array[b] >= 65 && array[b] <= 90 ) ||
              (array[b] >= 97 && array[b] <= 122 ) ||
              (array[b] == 196) ||
              (array[b] == 214) ||
              (array[b] == 220) ||
              (array[b] == 228) ||
              (array[b] == 246) ||
              (array[b] == 252) ||
              (array[b] == 223)
              ))
        b++;
        
        int len = b-a;
        if (len > 1)
        {  
          String token = new String (array, a, len).toLowerCase();
          for (int i=0;i<patterns.length;i++)
          {
            Matcher m = patterns[i].matcher(token);
            token = m.replaceAll(replacements[i]);
            m = null;
          }  
          tokens.add(token);
          token = null;
        }
        a = b+1;
       }
       else a++;  
    }      
    ArrayList result = stem (tokens);
    tokens = null;
    return result;
  }

  public ArrayList stem( Collection data )
  {
    ArrayList resultWords = new ArrayList(data.size());

    int pos = 0;
    Iterator it = data.iterator();
    while ( it.hasNext() )
    {
      String token = (String) it.next();
      
      if (isStopword(token)) continue;
      
      
      TextItem item = new TextItem( token );
      item.isStopword = false;
      item.position = ++pos;
      token = null;
 
      
      stemmer.setCurrent( item.term );
        
      for ( int i = repeat; i != 0; i-- )
      {
        try
        {
          stemMethod.invoke( stemmer, emptyArgs );
         }
          catch ( Exception e )
          {
            e.printStackTrace();
          }
        }
        
        item.stem = stemmer.getCurrent();
        if ( item.stem.length() > 1 )
          resultWords.add( item );
      
        item = null;
    }
    it = null;
     
    return resultWords;
  }
}
