/*
 * StatsTester.java
 *
 * Created on 22. August 2003, 13:29
 */

package org.unisb.dbs.stats;

import org.unisb.dbs.stats.distribution.*;
import org.unisb.dbs.stats.entropy.*;

import java.io.*;
import java.util.*;

/**
 *
 * @author  T
 */
public class StatsTester {
  
  public static void main( String[] args ) throws Exception {
    Vector set_a = new Vector();
    
    BufferedReader r = new BufferedReader( new FileReader( "c:\\samples_A.txt" ) ); //args[0]  ) );
    String line;
    while( ( line = r.readLine() ) != null ) {
      StringTokenizer t = new StringTokenizer( line );
      while( t.hasMoreElements() ) {
        try {
          double sample = Double.parseDouble( t.nextToken() );
          set_a.add( new Observation( sample ) );
        } catch ( NumberFormatException e ) {
          System.out.println( e );
        }
      }
    }

    Vector set_b = new Vector();
    
    r = new BufferedReader( new FileReader( "c:\\samples_B.txt" ) ); //args[0]  ) );
    while( ( line = r.readLine() ) != null ) {
      StringTokenizer t = new StringTokenizer( line );
      while( t.hasMoreElements() ) {
        try {
          double sample = Double.parseDouble( t.nextToken() );
          set_b.add( new Observation( sample ) );
        } catch ( NumberFormatException e ) {
          System.out.println( e );
        }
      }
    }
    
    PoissonDistribution a = new PoissonDistribution( set_a );
    PoissonDistribution b = new PoissonDistribution( set_b );

    KullBackLeiblerDivergence kl = new KullBackLeiblerDivergence( a, b );
    
    System.out.println( kl.getKL() );
  }
}
