/*
 * AbstractDistribtution.java
 *
 * Created on 22. August 2003, 11:59
 */

package org.unisb.dbs.stats.distribution;

import org.unisb.dbs.stats.estimators.*;
import java.util.*;

/**
 *
 * @author  T
 */
public abstract class AbstractDistribution implements Distribution {
  
  Hashtable map;
  
  public AbstractDistribution() {
    map = new Hashtable();
  }
  
  public AbstractDistribution( Set observations ) {
    map = new Hashtable();
    for ( Iterator i = observations.iterator(); i.hasNext(); ) {
      addObservation( (Observation)i.next() );
    }
  }
  
  public AbstractDistribution( Collection observations ) {
    map = new Hashtable();
    for ( Iterator i = observations.iterator(); i.hasNext(); ) {
      addObservation( (Observation)i.next() );
    }
  }
  
  public double entropy() {
    Estimator e = this.getEstimator();
    return 0.0;
  }
  
  public void addObservation( Observation o ) {
    Double d = (Double)map.get( new Double( o.getData() ) );
    if ( d == null ) {
      map.put( new Double( o.getData() ), new Double( o.getWeight() ) );
      System.out.println( "NEW: " + o.getData() + " " + o.getWeight() );
    } else {
      map.put( new Double( o.getData() ), new Double( d.doubleValue() + o.getWeight() ) );
      System.out.println( "ADDED: " + o.getData() + " " + d.doubleValue() + " " + o.getWeight() );
    }
  }
  
  public Set observations() {
    HashSet s = new HashSet( map.size() );
    for ( Iterator i = map.keySet().iterator(); i.hasNext(); ) {
      Double d = (Double)i.next();
      Observation o = new Observation( d.doubleValue(), ((Double)map.get( d )).doubleValue() );
      s.add( o );
    }
    return s;
  }
  
}
