/*
 * KullBackLeiblerDivergence.java
 *
 * Created on 22. August 2003, 10:08
 */

package org.unisb.dbs.stats.entropy;

import org.unisb.dbs.stats.distribution.*;
import org.unisb.dbs.stats.estimators.*;

/**
 *
 * @author  T
 */
public class KullBackLeiblerDivergence {
  
  private Distribution a;
  private Distribution b;
  
  /** Creates a new instance of KullBackLeiblerDivergence */
  public KullBackLeiblerDivergence( Distribution a, Distribution b ) {
    this.a = a;
    this.b = b;
  }
  
  public double getKL() {
    double kl = 0.0;
    
    if ( a instanceof PoissonDistribution && b instanceof PoissonDistribution ) {
      double mean_a = ((PoissonEstimator)a.getEstimator()).getMean();
      double mean_b = ((PoissonEstimator)b.getEstimator()).getMean();
      kl = Math.log( mean_b / mean_a ) + ( mean_a / mean_b -1 );
      return kl;
    }
    
    Estimator a = a.getEstimator();
    Estimator b = b.getEstimator();
    
    return kl;
  }
  
}
