package search;

import java.lang.*;
import java.util.*;

public class Error extends Constants

{
    private int status;   
    private Vector ErrorMessages;
    private Debugger debugger;
    private String log_path;
    
    private boolean error_status = false;
    
    public Error() 
    {
      log_path = LOG_PATH;  
      debugger = new Debugger(log_path);
      error_status = false;   
    }
    
    public Error(String path)
    {
     if (path!=null && path.length()>7)
      {
       log_path = path;   
       debugger = new Debugger(log_path);
       error_status = false;     
      }
    }
    
    public void set_error_status()
    {
      error_status = true;  
    }
    
    public void unset_error_status()
    {
      error_status = false;  
    }
    
    public boolean get_error_status()
    {
      return error_status;   
    } 
    
    public String get_error()
    {  
      return ErrorMessages.elementAt(status).toString();  
    }
 
    public synchronized void set_error(int error)
    {
     status=error;
     set_error_status();
     synchronized(log_semafor)
     {
      debugger.put(ErrorMessages.elementAt(error).toString());
     }
    }
 
    public synchronized void set_error_message(String _M)
    {   
     synchronized(log_semafor)
     {
      debugger.put(_M);  
     }
    }
    
}
