package search;

import java.util.*;
import java.lang.*;
import java.sql.*;
import oracle.jdbc.dbaccess.*; 
import oracle.jdbc.driver.*;
import oracle.sql.*;
import java.io.*;


public class KernelDB extends Error
{
    
private long id = new java.util.Date().getTime();
protected OracleConnection oracle_conn = null;
protected PreparedStatement SqlForm;
protected ResultSet rset = null;

protected String sLogin = LOGIN;
protected String sHost = HOST;
protected String sPass = PASSWORD;
protected String sService = SERVICE;

protected Math math;

public KernelDB()
{
   readAccount(ACCOUNT_PATH);
   OpenConnect();
}


 public void readAccount(String path) 
    {
     java.net.URL u = this.getClass().getClassLoader().getResource(path);

     try 
     {
      BufferedReader bf = new BufferedReader( new InputStreamReader( u.openStream() ) );
      String line = bf.readLine();

      while ( line != null ) {
        StringTokenizer st = new StringTokenizer( line, ";" );
        sLogin = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        sPass = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "" ) ).trim();
        sHost = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        sService = ( (String) ( st.hasMoreTokens() ? st.nextToken() : "-" ) ).trim();
        line = bf.readLine();
      }
      bf.close();
     }
     catch ( Exception e ) 
     {
       set_error_message("Can't read account information \n"+e.toString());
       set_error_status();
     }
   }



public boolean OpenConnect()
{
   String path="";
   try 
   {   
    DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());
    path="jdbc:oracle:thin:@(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST="+sHost+")(PORT=1521)))(CONNECT_DATA=(SERVICE_NAME="+sService+")(SERVER=dedicated)))";
    oracle_conn = (OracleConnection)DriverManager.getConnection(path,sLogin,sPass);   
    unset_error_status();
   }
    catch(Exception e) 
    {
     set_error_message("kernel constructor S: "+path+"\n"+e.toString());
     set_error_status();
    }   
   return !get_error_status();
}

public void CloseConnect()
{
  try 
  {
   if (oracle_conn != null && !oracle_conn.isClosed())  
   {
    oracle_conn.commit();
    oracle_conn.close();
    //set_error_message("Connection "+id+" is closed");
   }
  }
  catch (Exception e)
  {
    set_error_message("CLOSE kernelDB ERROR\n"+e.getMessage());  
  }
  set_error_status();
}

 public boolean createTable(String SQLquery)
 {
   if (get_error_status() || SQLquery == null) return false;
    try
    {
      SqlForm = oracle_conn.prepareStatement(SQLquery);
      SqlForm.execute();
      SqlForm.close();
      oracle_conn.commit();
      return true;  
    }
    catch(Exception e)
    {
      set_error_message("Error in CreateTable \n"+e.toString());  
    }
    return false;  
 }


}