package search;

import java.io.*;
import java.lang.*;
import javax.servlet.http.*;

public class Login extends Error
{
 private regDB DB;

 private String login;
 private String pass;
 private final static String[] ERROR_MESSAGES = {"please enter a login", "user does not exist or password is wrong"};
 private int error_status = -1;
 private Cookie cookie;
 private boolean justcamein = true;

 
   public Login() 
   {
     DB = new regDB();  
   }
   
   public void reset()
   {
    login = null;
    pass  = null;
    error_status = -1;
    justcamein = true;
   }
    
   public boolean process()
   {
     DB.OpenConnect();  
     if (login == null) error_status = 0;
     else
     {
       User user = DB.getUser(login, pass.hashCode());     
       if (user == null) error_status = 1;
        else
        {
         cookie = new Cookie(COOKIENAME, user.getID().toString());  
         cookie.setComment("SEEV's login cookie");
         cookie.setMaxAge(this.COOKIELIFETIME);
         error_status = -2;
         DB.CloseConnect();
         return true;
        }
     }
     DB.CloseConnect();
     return false;
   }
   
   public Cookie getCookie()
   {
     if (get_error_status() || error_status != -2) return null;
     return cookie;
   }
   
   public boolean isError()
   {
     if (error_status >= 0) return true;
     return false;
   }
   
   public boolean isSuccess()
   {
     if (error_status < -1) return true;
     return false;
   }
   
   public String getError()
   {
     if (justcamein) return "please enter your login and password";  
     if (error_status >= 0 && error_status < ERROR_MESSAGES.length) return ERROR_MESSAGES[error_status];
     else if (error_status == -2) return "You have logged in";
     else return "";
   }
   
   public void setlogin(String x)
   {
     login = x.toLowerCase();  
   }
   
   public String getlogin()
   {
     if (login != null) return login;  
     return "";
   }
   
   public void setsubmit(String x)
   {
     if (x!=null) justcamein = false;  
   }   

   public void setpass1(String x)
   {
     pass = x;
     set_error_message(x);
   }
   
}
