package search;

import java.lang.*;
import java.util.*;

public class Session extends Error

{
  private DBconnect DB;
  private long sessionID = 0;
  private long userID = DEFAULT_USER_ID;
  private String sessionIDStr = null;
  private String HostName;
  private Query query;
  private boolean is_results = false;

  //new query is posted by the known user
  public Session(DBconnect _DB, long userID, String _HostName, Query _query) 
    {
      if (_DB!=null && _query != null && !_DB.get_error_status()) 
      {
       DB=_DB;
       sessionID = getNewSessionID();
       query = _query;  
       HostName = _HostName;
       DB.createSession(sessionID, userID, HostName, query);
       is_results = false;
      }
      else set_error_status();
    }
  
  //new query is posted by anonimoius user 
   public Session(DBconnect _DB, String _HostName, Query _query) 
    {
      if (_DB!=null && _query != null && !_DB.get_error_status()) 
      {
       DB=_DB;
       sessionID = getNewSessionID();
       query = _query;
       HostName = _HostName;
       DB.createSession(sessionID, DEFAULT_USER_ID, HostName, query);
       is_results = false;
      }
      else set_error_status();
    }

   
   //MAY BE WE NEED TO CHECK ALSO AND HOSTNAME FOR THE SECURITY PURPOSES
    public Session(DBconnect _DB, long _sessionID) 
    {
      if (_DB!=null) 
      {
       DB=_DB;
       if (DB.checkSession(_sessionID)) 
       { 
         sessionID  = _sessionID;
         userID    =  DB.getUserID(sessionID);
         HostName  =  DB.getHostName(sessionID);
         query     =  DB.getQuery(sessionID);
         if (userID == BAD_ID || HostName == null || query == null) set_error_status();
       } 
       else set_error_message("Session: "+sessionID+" User: "+userID);
      }
      else set_error_status();
    }
    
    
    public Result_List get_unit_list()
    {
       Result_List Temp = null;      
       if (get_error_status()) return null; 
       Temp = DB.getSessionList(sessionID);
       if (Temp == null) 
        {
         Temp = DB.getNewList(query, sessionID);
        }
       return Temp;  
    }
    
    private boolean storeSessionList(Result_List RL)
    {
     if (RL == null) {set_error_message("Can not store an empty result list"); return false;}
     if (DB.createSessionTable(sessionID))
      if (DB.storeSessionList(sessionID, RL)) return true;
     set_error_message("Data Base problems: can not store session's data");
     return false;
    }
    
    public boolean deleteNegative(Feedback feedback)
    {
      if (feedback == null || feedback.get_error_status() || feedback.getNumNeg() < 1) return false;
      long[] docs = new long[feedback.getNumNeg()];
      int n = feedback.getLength();
      for (int i=0, k=0; i<n; i++)
        if (feedback.getStatus(i) == NEGATIV) 
        {
          docs[k] = feedback.getDOCID(i);         
          k++;
        }
      return DB.deleteNegativ(docs, sessionID);      
    }
    
    private long getNewSessionID()
    {
     return new Date().getTime();   
    }
        
    public long getsessionID()
    {
      if (get_error_status()) return BAD_ID;
      return sessionID;  
    }
    
    public long getuserID()
    {
      if (get_error_status()) return BAD_ID;
      return userID;  
    }
    
    public Query getQuery()
    {
      if (get_error_status()) return null;
      return query;
    }    
    
       
}
