package search;

import java.util.*;
import java.lang.*;

public class Term_Parser extends Error implements Comparable
{
    
    
private String keyword = new String();
private int TYPE = 0;

/*
 ! = not_term
 % = wildcard
 [ = right bracket
 ] = left bracket
 _ = AND
 AND = AND
 OR = OR
 | = OR
 domain:www.www.xx/../ = domain
 a..z0..9 = term
**/

 public Term_Parser(String term, boolean TmFt) 
 {
  String _term = term;
  if (_term == null || _term == "") set_error_status();
  else
  if (_term.length()==1)
      {
       switch (_term.charAt(0))
       {
           case '[': {keyword=""; TYPE = LBRACKET;} break;
           case ']': {keyword=""; TYPE = RBRACKET;} break;
           case ' ': {keyword=""; TYPE = AND;} break;
           case '|': {keyword=""; TYPE = OR;} break;   
       }
      }
     else
     {
       if (_term.equals("AND")) {keyword=""; TYPE=AND;}
        else if (_term.equals("OR")) {keyword=""; TYPE=OR;}
         else 
         {
           keyword = _term;
           TYPE = TERM;
           if (_term.startsWith("!") || _term.startsWith("-"))
            {
              _term = _term.substring(1);
              keyword = _term;
              TYPE = NOT_TERM;
            }
           if (_term.length()>7 && _term.startsWith("domain:"))
            {
              _term = _term.substring(7);
              keyword = _term;
              if (TYPE == NOT_TERM) TYPE = NOT_DOMAIN;
               else TYPE = DOMAIN;
            } 
           if (_term.length()>3&&_term.endsWith("%"))
            if (TYPE!=DOMAIN&&TYPE!=NOT_DOMAIN)
            { 
              keyword = _term;
              if (TYPE==NOT_TERM) TYPE = NOT_WILDCARD;
               else TYPE = WILDCARD;                
            }   
            else
            {  
            }    
         }  
       if (!TmFt && (TYPE == TERM || TYPE == NOT_TERM || TYPE == WILDCARD || TYPE == NOT_WILDCARD)) keyword = Stem(keyword); 
     }  
 }
 
 public String Stem(String origin)
 {   
   return stemmer.stem(origin);
 }
 
 public int getTYPE()
 {
   return TYPE;
 }
 
 public String getTERM()
 {
   return keyword;
 }
 
 public boolean setTYPE(int type)
 {
  if (type>=3 && type<=6) {keyword=""; TYPE=type;}
   else 
    if (keyword!="") {TYPE = type;}
    if (TYPE == CLASS) keyword = keyword.toUpperCase();
     else return false;
  return true;
 }

 /*IMPORTANT COMMENTS
 priority in group
 (query without brackets one group)
 
 1. inClass
 2. domain
 3. not domain
 4. not term
 5. not wildcard
 6. term
 7. wildcard
 */ 
 public int compareTo (Object o)
 {
  int _TYPE = 0;
  if (o != null) _TYPE = ((Term_Parser)o).getTYPE();
   else return 0;
  int t=0;
  switch (TYPE)
  {
      case CLASS:         t=1; break;
      case DOMAIN:        t=2; break;
      case NOT_DOMAIN:    t=3; break;
      case NOT_TERM:      t=4; break;
      case NOT_WILDCARD:  t=5; break;
      case TERM:          t=6; break;
      case WILDCARD:      t=7; break;
      default:                      t=8;
  }
  switch (_TYPE)
  {
      case CLASS:         t-=1; break;
      case DOMAIN:        t-=2; break;
      case NOT_DOMAIN:    t-=3; break;
      case NOT_TERM:      t-=4; break;
      case NOT_WILDCARD:  t-=5; break;
      case TERM:          t-=6; break;
      case WILDCARD:      t-=7; break;
      default:                      t-=8;
  }  
  
  if (t<=0) return -1;
   else if (t>0) return 1;
  return 0;   
 }
}
