package search;

import java.lang.*;
import java.util.*;

public class User extends Error
{
  private Long      userID;
  private String    login;
  private String    email;    
  private String    pass;
  private int       passCode;
  private String    name;    

  
  public User(long _userID, String _login, String _email, int _pass, String _name)
  {
    if (_userID == 0 || _login == null || _email == null || _pass == 0 || _name == null) set_error_status();
    else 
     {
      userID = new Long(_userID);
      login  = _login;
      email  = _email;
      passCode   = _pass;
      name   = _name;
     }    
  }
  
  public User(String _login, String _email, String _pass, String _name) 
  {
    if (_login == null || _email == null || _pass == null || _name == null) set_error_status();
    else
     {
      userID = new Long(getNewID());
      login  = _login;
      email  = _email;
      pass   = _pass;
      passCode = pass.hashCode();
      name   = _name;
     }
  }
  
  
  public Long getID()
  {
    if (get_error_status()) return null;
    return userID;  
  }
     
  public long getID_long_value()
  {
    if (get_error_status()) return 0;
    return userID.longValue();  
  }
  
  public String getEmail()
  {
    if (get_error_status()) return null;
    return email;
  }

  public String getName()
  {
    if (get_error_status()) return null;
    return name;
  }

  public String getLogin()
  {
    if (get_error_status()) return null;
    return login;
  }

  public int getPass()
  {
    if (get_error_status()) return 0;
    return passCode;  
  }
  
}
