package search;

import java.sql.*;
import oracle.sql.*;

public class regDB extends KernelDB
{

    
    public boolean isLogin(String x)
    {
      if (x == null) return false;
      try
      {
        String SQLquery = "select userid from "+USER_TABLE+" where login = ?";
        PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
        SqlForm.setString(1, x.toLowerCase());
        ResultSet rset = SqlForm.executeQuery();
        boolean t = false;        
        if (rset.next()) t = true;
        rset.close();
        SqlForm.close();  
        return t;
      }
      catch (Exception e)
      {
        set_error_message("isLogin"+e.toString());  
      }
      return false;
    }
    
    public boolean isEmail(String x)
    {
      if (x == null) return false;
      try
      {
        String SQLquery = "select userid from "+USER_TABLE+" where email = ?";
        PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
        SqlForm.setString(1, x.toLowerCase());
        ResultSet rset = SqlForm.executeQuery();
        boolean t = false;        
        if (rset.next()) t = true;
        rset.close();
        SqlForm.close();  
        return t;
      }
      catch (Exception e)
      {
        set_error_message("isEmail"+e.toString());  
      }
      return false;
    }

  public boolean createUser(User user)
  {   
   if (get_error_status() || user.get_error_status()) return false;  
   try
   {
    String SQLquery = "insert into "+USER_TABLE+"(userID, name, email, login, pass, regdate) values(?, ?, ?, ?, ?, ?)";
    PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
    SqlForm.setLong(1, user.getID_long_value());
    SqlForm.setString(2, user.getName());
    SqlForm.setString(3, user.getEmail().toLowerCase());
    SqlForm.setString(4, user.getLogin().toLowerCase());
    SqlForm.setInt(5, user.getPass());
    java.sql.Date   date    = new java.sql.Date(new java.util.Date().getTime());
    SqlForm.setDate(6, date);
    SqlForm.execute();
    SqlForm.close();
   }
  catch (Exception e)
  {
   set_error_message("User ERROR \n"+e.getMessage());
   return false;
  }
  return true;       
 }

  
 public User getUser(String userid)
 {
      if (get_error_status() || userid == null) return null;
      try
      {
        String SQLquery = "select * from "+USER_TABLE+" where userid = ?";
        PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
        SqlForm.setLong(1, new Long(userid).longValue());
        ResultSet rset = SqlForm.executeQuery();
        User user = null;
        if (rset.next())
         {
           String name  = rset.getString("name");
           String email = rset.getString("email");
           long userID  = rset.getLong("userid");
           int  pass    = rset.getInt("pass");
           String login = rset.getString("login");
           user = new User(userID, login, email, pass, name);
         }
        rset.close();
        SqlForm.close();  
        return user;
      }
      catch (Exception e)
      {
        set_error_message("getUser_id "+e.toString());
      }
      return null;     
  }
  
  
 public User getUser(String login, int pass)
 {
      if (get_error_status() || login == null || pass == 0) return null;
      try
      {
        String SQLquery = "select * from "+USER_TABLE+" where login = ? and pass = ?";
        PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
        SqlForm.setString(1, login.toLowerCase());
        SqlForm.setInt(2, pass);
        ResultSet rset = SqlForm.executeQuery();
        User user = null;
        if (rset.next())
         {
           String name  = rset.getString("name");
           String email = rset.getString("email");
           long userID  = rset.getLong("userid");
           user = new User(userID, login, email, pass, name);
         }
        rset.close();
        SqlForm.close();  
        return user;
      }
      catch (Exception e)
      {
        set_error_message("getUser_pass"+e.toString());
      }
      return null;     
 }
}
