/**
 * SEEV 1.0 an advanced search engine for BINGO!
 * @author  Eske Vladimir
 * 2003
 * @address eske@cs.uni-sb.de
 * All rights reserved
 * Not for commercial use
 */
package search.test;

import java.util.*;
import java.lang.*;
import search.*;


public class Tester extends search.Error{
private testDB DB;
private Vector terms = new Vector();
private int NT = 1;
private TestThread[] TT;
private int SoulCounter = 0;
private long num_terms = 0;
private Feedback[] feedbacks;
    
    public Tester() 
    {
      DB = new testDB("account.dat");    
    }
    
    public void setNT(int _NT)
    {
      if (_NT<1) NT=1;
       else NT = _NT;
    }
    
    public void StartTest()
    { 
      set_error_message("Test started at "+new Date().toGMTString());  
      DB.OpenConnect();
      terms = (Vector)DB.list_of_keys(0);
      feedbacks = DB.getAllFeedbacks();
      
      set_error_message("tester: "+terms.size()+" NT="+NT);
      TT = new TestThread[NT];
      int n = terms.size();
      int f = feedbacks.length;
      int k = (int)Math.floor(n/NT);
      int k_f = (int)Math.floor(f/NT);
      Random R = new Random();
      for (int i=0; i<NT; i++)
       {           
         int j = R.nextInt(NT);
         Object[] C1 = terms.subList(k*i, k*(i+1)-1).toArray();
         Object[] C2 = terms.subList(k*j, k*(j+1)-1).toArray();
         Feedback[] F =  new Feedback[k_f];
         for (int l = 0; l < k_f; l++)
           F[l] = feedbacks[l+k_f*i];
         TT[i] = new TestThread(C1, C2, F);
       } 
      
      for (int i=0; i<NT; i++)
       {
         new Thread(TT[i]).start();  
       }
      
      try 
      {
        while (SoulCounter < NT)
         {
           SoulCounter = 0;              
           for (int i=0; i<NT; i++)
            if (!TT[i].get_error_status()) synchronized (TT[i]) {TT[i].wait();}
             else SoulCounter++; 
         }
      }
      catch (Exception e) 
      {
        set_error_message("Tester CAN'T WAIT "+SoulCounter+"\n"+e.toString());  
      }
    DB.CloseConnect();  
    set_error_message("Tester: FINISH");  
    }
    
}
