package search.test;

import java.util.*;
import java.lang.*;
import java.sql.*;
import oracle.jdbc.dbaccess.*; 
import oracle.jdbc.driver.*;
import oracle.sql.*;
import java.io.*;
import search.*;

public class testDB extends search.KernelDB
{   
 public testDB()
 {
 }
 
 public testDB(String path)
 {
  if (path == null) readAccount(ACCOUNT_PATH); 
  else readAccount(path);
  OpenConnect();       
 }
 
 public boolean insert_query(String query)
 {
   if (query == null) return false;
   try
   {
     PreparedStatement SqlForm = oracle_conn.prepareStatement(query);
     SqlForm.executeUpdate();
     oracle_conn.commit();
     SqlForm.close();
     return true;
   }
   catch (Exception e)
   {
    e.printStackTrace();
   }
   return false;
 }
 
 public long num_of_keys(int i)
 {
   if (i < 0 || i >= GLOBAL_NF) return 0;  
   String SQLquery="select count(distinct(key)) from "+this.FEATURE_NAME_PREFIX+i+" group by key having count(docid) > "+25;
   try
   {
     PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
     ResultSet rset = SqlForm.executeQuery();
     long num = 0;
     if (rset.next())
      {
        num = rset.getLong(1);   
      }
     rset.close();
     SqlForm.close();
     return num;
   }
   catch (Exception e)
   {
    e.printStackTrace();
   } 
   return 0;
 }
 
 public Collection list_of_keys(int i)
 {
   if (i < 0 || i >= GLOBAL_NF) return null;  
   String SQLquery="select distinct(key) from "+this.FEATURE_NAME_PREFIX+i+" group by key having count(docid) > "+25;
   try
   {
     PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
     ResultSet rset = SqlForm.executeQuery();
     Vector V = new Vector();
     while (rset.next())
      {
        V.add(rset.getString(1));
      }
     rset.close();
     SqlForm.close();
     return V;
   }
   catch (Exception e)
   {
    e.printStackTrace();
    set_error_message("list_of_keys error \n"+SQLquery);
   } 
   return null;
 }
 
  public Feedback[] getAllFeedbacks()
  {
    if (get_error_status()) return null; 
    try
    {
        String SQLquery = "Select count(*) from "+this.FEEDBACK_BLOB_TABLE;
        PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
        ResultSet rset = SqlForm.executeQuery();
        int n = 0;
        if (rset.next())
         {
           n = rset.getInt(1);  
         }
        rset.close();
        SqlForm.close();
        
        if (n <= 0) return null;
        
        SQLquery = "Select sessionID from "+this.FEEDBACK_BLOB_TABLE;
        SqlForm = oracle_conn.prepareStatement(SQLquery);
        rset = SqlForm.executeQuery();
        Feedback[] feedbacks = new Feedback[n];
        int k = 0;
        while (rset.next() && k < n)
         {
           long sessionID = rset.getLong(1);  
           feedbacks[k] = getBlobFeedback(sessionID); 
           k++;
         }
        rset.close();
        SqlForm.close();
        
        return feedbacks;
    }
    catch (Exception e)
    {
     set_error_message("getAllFeedback form blob error \n"+e.toString());
     return null;
    }     
  }
 
  public Feedback getBlobFeedback(long sessionID)
  {
    if (get_error_status()) return null; 
    try
    {
     String SQLquery = "select feedback from "+this.FEEDBACK_BLOB_TABLE+" where sessionID = ?";  
     PreparedStatement SqlForm = oracle_conn.prepareStatement(SQLquery);
     SqlForm.setLong(1, sessionID);
     ResultSet rset2 = SqlForm.executeQuery();
     if (rset2.next()) 
      {
        oracle.sql.BLOB blob = ((OracleResultSet)rset2).getBLOB(1);
        ObjectInputStream ois = new ObjectInputStream(blob.getBinaryStream());
        Feedback _feedback = (Feedback)ois.readObject();
        ois.close();
        rset2.close();
        SqlForm.close();
        return _feedback;
      }
     rset2.close();
     SqlForm.close();
    }
    catch (Exception e)
    {
     set_error_message("getFeedback form blob error \n"+e.toString());
     return null;
    }
    return null;
 }
}